/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 6.6.1
 * @date    2020-06-15T13:21:34.180Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return i(null==e&&r.path)}},r.exports),r.exports}function n(t){return t&&t.default||t}function i(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}var a=function(t){return t&&t.Math==Math&&t},o=a("object"==typeof globalThis&&globalThis)||a("object"==typeof window&&window)||a("object"==typeof self&&self)||a("object"==typeof e&&e)||Function("return this")(),s=function(t){try{return!!t()}catch(t){return!0}},u=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),c={}.propertyIsEnumerable,l=Object.getOwnPropertyDescriptor,f={f:l&&!c.call({1:2},1)?function(t){var e=l(this,t);return!!e&&e.enumerable}:c},h=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d={}.toString,p=function(t){return d.call(t).slice(8,-1)},y="".split,v=s((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?y.call(t,""):Object(t)}:Object,m=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},g=function(t){return v(m(t))},_=function(t){return"object"==typeof t?null!==t:"function"==typeof t},w=function(t,e){if(!_(t))return t;var r,n;if(e&&"function"==typeof(r=t.toString)&&!_(n=r.call(t)))return n;if("function"==typeof(r=t.valueOf)&&!_(n=r.call(t)))return n;if(!e&&"function"==typeof(r=t.toString)&&!_(n=r.call(t)))return n;throw TypeError("Can't convert object to primitive value")},b={}.hasOwnProperty,S=function(t,e){return b.call(t,e)},k=o.document,O=_(k)&&_(k.createElement),D=function(t){return O?k.createElement(t):{}},x=!u&&!s((function(){return 7!=Object.defineProperty(D("div"),"a",{get:function(){return 7}}).a})),M=Object.getOwnPropertyDescriptor,Y={f:u?M:function(t,e){if(t=g(t),e=w(e,!0),x)try{return M(t,e)}catch(t){}if(S(t,e))return h(!f.f.call(t,e),t[e])}},T=/#|\.prototype\./,P=function(t,e){var r=A[j(t)];return r==E||r!=N&&("function"==typeof e?s(e):!!e)},j=P.normalize=function(t){return String(t).replace(T,".").toLowerCase()},A=P.data={},N=P.NATIVE="N",E=P.POLYFILL="P",I=P,C={},R=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},L=function(t,e,r){if(R(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,n){return t.call(e,r,n)};case 3:return function(r,n,i){return t.call(e,r,n,i)}}return function(){return t.apply(e,arguments)}},F=function(t){if(!_(t))throw TypeError(String(t)+" is not an object");return t},W=Object.defineProperty,U={f:u?W:function(t,e,r){if(F(t),e=w(e,!0),F(r),x)try{return W(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},H=u?function(t,e,r){return U.f(t,e,h(1,r))}:function(t,e,r){return t[e]=r,t},G=Y.f,V=function(t){var e=function(e,r,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},z=function(t,e){var r,n,i,a,s,u,c,l,f=t.target,h=t.global,d=t.stat,p=t.proto,y=h?o:d?o[f]:(o[f]||{}).prototype,v=h?C:C[f]||(C[f]={}),m=v.prototype;for(i in e)r=!I(h?i:f+(d?".":"#")+i,t.forced)&&y&&S(y,i),s=v[i],r&&(u=t.noTargetGet?(l=G(y,i))&&l.value:y[i]),a=r&&u?u:e[i],r&&typeof s==typeof a||(c=t.bind&&r?L(a,o):t.wrap&&r?V(a):p&&"function"==typeof a?L(Function.call,a):a,(t.sham||a&&a.sham||s&&s.sham)&&H(c,"sham",!0),v[i]=c,p&&(S(C,n=f+"Prototype")||H(C,n,{}),C[n][i]=a,t.real&&m&&!m[i]&&H(m,i,a)))},q=Array.isArray||function(t){return"Array"==p(t)},Z=Math.ceil,$=Math.floor,B=function(t){return isNaN(t=+t)?0:(t>0?$:Z)(t)},J=Math.min,Q=function(t){return t>0?J(B(t),9007199254740991):0},K=function(t,e,r,n,i,a,o,s){for(var u,c=i,l=0,f=!!o&&L(o,s,3);l<n;){if(l in r){if(u=f?f(r[l],l,e):r[l],a>0&&q(u))c=K(t,e,u,Q(u.length),c,a-1)-1;else{if(c>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[c]=u}c++}l++}return c},X=K,tt=function(t){return Object(m(t))},et=o["__core-js_shared__"]||function(t,e){try{H(o,t,e)}catch(r){o[t]=e}return e}("__core-js_shared__",{}),rt=r((function(t){(t.exports=function(t,e){return et[t]||(et[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),nt=0,it=Math.random(),at=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++nt+it).toString(36)},ot=!!Object.getOwnPropertySymbols&&!s((function(){return!String(Symbol())})),st=ot&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,ut=rt("wks"),ct=o.Symbol,lt=st?ct:ct&&ct.withoutSetter||at,ft=function(t){return S(ut,t)||(ot&&S(ct,t)?ut[t]=ct[t]:ut[t]=lt("Symbol."+t)),ut[t]},ht=ft("species"),dt=function(t,e){var r;return q(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!q(r.prototype)?_(r)&&null===(r=r[ht])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)};z({target:"Array",proto:!0},{flatMap:function(t){var e,r=tt(this),n=Q(r.length);return R(t),(e=dt(r,0)).length=X(e,r,r,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var pt,yt,vt=function(t){return C[t+"Prototype"]},mt=vt("Array").flatMap,gt=Array.prototype,_t=function(t){var e=t.flatMap;return t===gt||t instanceof Array&&e===gt.flatMap?mt:e},wt=[].push,bt=function(t){var e=1==t,r=2==t,n=3==t,i=4==t,a=6==t,o=5==t||a;return function(s,u,c,l){for(var f,h,d=tt(s),p=v(d),y=L(u,c,3),m=Q(p.length),g=0,_=l||dt,w=e?_(s,m):r?_(s,0):void 0;m>g;g++)if((o||g in p)&&(h=y(f=p[g],g,d),t))if(e)w[g]=h;else if(h)switch(t){case 3:return!0;case 5:return f;case 6:return g;case 2:wt.call(w,f)}else if(i)return!1;return a?-1:n||i?i:w}},St={forEach:bt(0),map:bt(1),filter:bt(2),some:bt(3),every:bt(4),find:bt(5),findIndex:bt(6)},kt=function(t){return"function"==typeof t?t:void 0},Ot=function(t,e){return arguments.length<2?kt(C[t])||kt(o[t]):C[t]&&C[t][e]||o[t]&&o[t][e]},Dt=Ot("navigator","userAgent")||"",xt=o.process,Mt=xt&&xt.versions,Yt=Mt&&Mt.v8;Yt?yt=(pt=Yt.split("."))[0]+pt[1]:Dt&&(!(pt=Dt.match(/Edge\/(\d+)/))||pt[1]>=74)&&(pt=Dt.match(/Chrome\/(\d+)/))&&(yt=pt[1]);var Tt=yt&&+yt,Pt=ft("species"),jt=function(t){return Tt>=51||!s((function(){var e=[];return(e.constructor={})[Pt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},At=Object.defineProperty,Nt={},Et=function(t){throw t},It=function(t,e){if(S(Nt,t))return Nt[t];e||(e={});var r=[][t],n=!!S(e,"ACCESSORS")&&e.ACCESSORS,i=S(e,0)?e[0]:Et,a=S(e,1)?e[1]:void 0;return Nt[t]=!!r&&!s((function(){if(n&&!u)return!0;var t={length:-1};n?At(t,1,{enumerable:!0,get:Et}):t[1]=1,r.call(t,i,a)}))},Ct=St.map,Rt=jt("map"),Lt=It("map");z({target:"Array",proto:!0,forced:!Rt||!Lt},{map:function(t){return Ct(this,t,arguments.length>1?arguments[1]:void 0)}});var Ft=vt("Array").map,Wt=Array.prototype,Ut=function(t){var e=t.map;return t===Wt||t instanceof Array&&e===Wt.map?Ft:e},Ht=St.filter,Gt=jt("filter"),Vt=It("filter");z({target:"Array",proto:!0,forced:!Gt||!Vt},{filter:function(t){return Ht(this,t,arguments.length>1?arguments[1]:void 0)}});var zt=vt("Array").filter,qt=Array.prototype,Zt=function(t){var e=t.filter;return t===qt||t instanceof Array&&e===qt.filter?zt:e},$t=function(t){return function(e,r,n,i){R(r);var a=tt(e),o=v(a),s=Q(a.length),u=t?s-1:0,c=t?-1:1;if(n<2)for(;;){if(u in o){i=o[u],u+=c;break}if(u+=c,t?u<0:s<=u)throw TypeError("Reduce of empty array with no initial value")}for(;t?u>=0:s>u;u+=c)u in o&&(i=r(i,o[u],u,a));return i}},Bt=function(t,e){var r=[][t];return!!r&&s((function(){r.call(null,e||function(){throw 1},1)}))},Jt={left:$t(!1),right:$t(!0)}.left,Qt=Bt("reduce"),Kt=It("reduce",{1:0});z({target:"Array",proto:!0,forced:!Qt||!Kt},{reduce:function(t){return Jt(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Xt=vt("Array").reduce,te=Array.prototype,ee=function(t){var e=t.reduce;return t===te||t instanceof Array&&e===te.reduce?Xt:e},re=[].slice,ne={},ie=function(t,e,r){if(!(e in ne)){for(var n=[],i=0;i<e;i++)n[i]="a["+i+"]";ne[e]=Function("C,a","return new C("+n.join(",")+")")}return ne[e](t,r)},ae=Function.bind||function(t){var e=R(this),r=re.call(arguments,1),n=function(){var i=r.concat(re.call(arguments));return this instanceof n?ie(e,i.length,i):e.apply(t,i)};return _(e.prototype)&&(n.prototype=e.prototype),n};z({target:"Function",proto:!0},{bind:ae});var oe=vt("Function").bind,se=Function.prototype,ue=function(t){var e=t.bind;return t===se||t instanceof Function&&e===se.bind?oe:e};var ce=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};z({target:"Object",stat:!0,forced:!u,sham:!u},{defineProperty:U.f});var le=r((function(t){var e=C.Object,r=t.exports=function(t,r,n){return e.defineProperty(t,r,n)};e.defineProperty.sham&&(r.sham=!0)})),fe=le;function he(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),fe(t,n.key,n)}}var de=function(t,e,r){return e&&he(t.prototype,e),r&&he(t,r),t};var pe=function(){function t(e,r,n){var i,a,o;ce(this,t),this._source=e,this._transformers=r,this._target=n,this._listeners={add:ue(i=this._add).call(i,this),remove:ue(a=this._remove).call(a,this),update:ue(o=this._update).call(o,this)}}return de(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return ee(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),ye=function(){function t(e){ce(this,t),this._source=e,this._transformers=[]}return de(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return Zt(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return Ut(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return _t(e).call(e,t)})),this}},{key:"to",value:function(t){return new pe(this._source,this._transformers,t)}}]),t}(),ve=le,me=Math.max,ge=Math.min,_e=function(t,e){var r=B(t);return r<0?me(r+e,0):ge(r,e)},we=function(t){return function(e,r,n){var i,a=g(e),o=Q(a.length),s=_e(n,o);if(t&&r!=r){for(;o>s;)if((i=a[s++])!=i)return!0}else for(;o>s;s++)if((t||s in a)&&a[s]===r)return t||s||0;return!t&&-1}},be={includes:we(!0),indexOf:we(!1)},Se={},ke=be.indexOf,Oe=function(t,e){var r,n=g(t),i=0,a=[];for(r in n)!S(Se,r)&&S(n,r)&&a.push(r);for(;e.length>i;)S(n,r=e[i++])&&(~ke(a,r)||a.push(r));return a},De=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],xe=Object.keys||function(t){return Oe(t,De)},Me=u?Object.defineProperties:function(t,e){F(t);for(var r,n=xe(e),i=n.length,a=0;i>a;)U.f(t,r=n[a++],e[r]);return t};z({target:"Object",stat:!0,forced:!u,sham:!u},{defineProperties:Me});var Ye=r((function(t){var e=C.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)})),Te=De.concat("length","prototype"),Pe={f:Object.getOwnPropertyNames||function(t){return Oe(t,Te)}},je={f:Object.getOwnPropertySymbols},Ae=Ot("Reflect","ownKeys")||function(t){var e=Pe.f(F(t)),r=je.f;return r?e.concat(r(t)):e},Ne=function(t,e,r){var n=w(e);n in t?U.f(t,n,h(0,r)):t[n]=r};z({target:"Object",stat:!0,sham:!u},{getOwnPropertyDescriptors:function(t){for(var e,r,n=g(t),i=Y.f,a=Ae(n),o={},s=0;a.length>s;)void 0!==(r=i(n,e=a[s++]))&&Ne(o,e,r);return o}});var Ee=C.Object.getOwnPropertyDescriptors,Ie={},Ce=Function.toString;"function"!=typeof et.inspectSource&&(et.inspectSource=function(t){return Ce.call(t)});var Re,Le,Fe,We=et.inspectSource,Ue=o.WeakMap,He="function"==typeof Ue&&/native code/.test(We(Ue)),Ge=rt("keys"),Ve=function(t){return Ge[t]||(Ge[t]=at(t))},ze=o.WeakMap;if(He){var qe=new ze,Ze=qe.get,$e=qe.has,Be=qe.set;Re=function(t,e){return Be.call(qe,t,e),e},Le=function(t){return Ze.call(qe,t)||{}},Fe=function(t){return $e.call(qe,t)}}else{var Je=Ve("state");Se[Je]=!0,Re=function(t,e){return H(t,Je,e),e},Le=function(t){return S(t,Je)?t[Je]:{}},Fe=function(t){return S(t,Je)}}var Qe,Ke,Xe,tr={set:Re,get:Le,has:Fe,enforce:function(t){return Fe(t)?Le(t):Re(t,{})},getterFor:function(t){return function(e){var r;if(!_(e)||(r=Le(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},er=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),rr=Ve("IE_PROTO"),nr=Object.prototype,ir=er?Object.getPrototypeOf:function(t){return t=tt(t),S(t,rr)?t[rr]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?nr:null},ar=(ft("iterator"),!1);[].keys&&("next"in(Xe=[].keys())?(Ke=ir(ir(Xe)))!==Object.prototype&&(Qe=Ke):ar=!0),null==Qe&&(Qe={});var or,sr={IteratorPrototype:Qe,BUGGY_SAFARI_ITERATORS:ar},ur=Ot("document","documentElement"),cr=Ve("IE_PROTO"),lr=function(){},fr=function(t){return"<script>"+t+"<\/script>"},hr=function(){try{or=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;hr=or?function(t){t.write(fr("")),t.close();var e=t.parentWindow.Object;return t=null,e}(or):((e=D("iframe")).style.display="none",ur.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(fr("document.F=Object")),t.close(),t.F);for(var r=De.length;r--;)delete hr.prototype[De[r]];return hr()};Se[cr]=!0;var dr=Object.create||function(t,e){var r;return null!==t?(lr.prototype=F(t),r=new lr,lr.prototype=null,r[cr]=t):r=hr(),void 0===e?r:Me(r,e)},pr={};pr[ft("toStringTag")]="z";var yr="[object z]"===String(pr),vr=ft("toStringTag"),mr="Arguments"==p(function(){return arguments}()),gr=yr?p:function(t){var e,r,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),vr))?r:mr?p(e):"Object"==(n=p(e))&&"function"==typeof e.callee?"Arguments":n},_r=yr?{}.toString:function(){return"[object "+gr(this)+"]"},wr=U.f,br=ft("toStringTag"),Sr=function(t,e,r,n){if(t){var i=r?t:t.prototype;S(i,br)||wr(i,br,{configurable:!0,value:e}),n&&!yr&&H(i,"toString",_r)}},kr=sr.IteratorPrototype,Or=function(){return this},Dr=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}return function(r,n){return F(r),function(t){if(!_(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(r,n):r.__proto__=n,r}}():void 0),xr=function(t,e,r,n){n&&n.enumerable?t[e]=r:H(t,e,r)},Mr=sr.IteratorPrototype,Yr=sr.BUGGY_SAFARI_ITERATORS,Tr=ft("iterator"),Pr=function(){return this},jr=function(t,e,r,n,i,a,o){!function(t,e,r){var n=e+" Iterator";t.prototype=dr(kr,{next:h(1,r)}),Sr(t,n,!1,!0),Ie[n]=Or}(r,e,n);var s,u,c,l=function(t){if(t===i&&v)return v;if(!Yr&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},f=e+" Iterator",d=!1,p=t.prototype,y=p[Tr]||p["@@iterator"]||i&&p[i],v=!Yr&&y||l(i),m="Array"==e&&p.entries||y;if(m&&(s=ir(m.call(new t)),Mr!==Object.prototype&&s.next&&(Sr(s,f,!0,!0),Ie[f]=Pr)),"values"==i&&y&&"values"!==y.name&&(d=!0,v=function(){return y.call(this)}),o&&p[Tr]!==v&&H(p,Tr,v),Ie[e]=v,i)if(u={values:l("values"),keys:a?v:l("keys"),entries:l("entries")},o)for(c in u)(Yr||d||!(c in p))&&xr(p,c,u[c]);else z({target:e,proto:!0,forced:Yr||d},u);return u},Ar=tr.set,Nr=tr.getterFor("Array Iterator");jr(Array,"Array",(function(t,e){Ar(this,{type:"Array Iterator",target:g(t),index:0,kind:e})}),(function(){var t=Nr(this),e=t.target,r=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:n,done:!1}:"values"==r?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");Ie.Arguments=Ie.Array;var Er=ft("toStringTag");for(var Ir in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Cr=o[Ir],Rr=Cr&&Cr.prototype;Rr&&gr(Rr)!==Er&&H(Rr,Er,Ir),Ie[Ir]=Ie.Array}var Lr=St.forEach,Fr=Bt("forEach"),Wr=It("forEach"),Ur=Fr&&Wr?[].forEach:function(t){return Lr(this,t,arguments.length>1?arguments[1]:void 0)};z({target:"Array",proto:!0,forced:[].forEach!=Ur},{forEach:Ur});var Hr=vt("Array").forEach,Gr=Array.prototype,Vr={DOMTokenList:!0,NodeList:!0},zr=function(t){var e=t.forEach;return t===Gr||t instanceof Array&&e===Gr.forEach||Vr.hasOwnProperty(gr(t))?Hr:e},qr=Y.f,Zr=s((function(){qr(1)}));z({target:"Object",stat:!0,forced:!u||Zr,sham:!u},{getOwnPropertyDescriptor:function(t,e){return qr(g(t),e)}});var $r=r((function(t){var e=C.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),Br=Pe.f,Jr={}.toString,Qr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Kr={f:function(t){return Qr&&"[object Window]"==Jr.call(t)?function(t){try{return Br(t)}catch(t){return Qr.slice()}}(t):Br(g(t))}},Xr={f:ft},tn=U.f,en=function(t){var e=C.Symbol||(C.Symbol={});S(e,t)||tn(e,t,{value:Xr.f(t)})},rn=St.forEach,nn=Ve("hidden"),an=ft("toPrimitive"),on=tr.set,sn=tr.getterFor("Symbol"),un=Object.prototype,cn=o.Symbol,ln=Ot("JSON","stringify"),fn=Y.f,hn=U.f,dn=Kr.f,pn=f.f,yn=rt("symbols"),vn=rt("op-symbols"),mn=rt("string-to-symbol-registry"),gn=rt("symbol-to-string-registry"),_n=rt("wks"),wn=o.QObject,bn=!wn||!wn.prototype||!wn.prototype.findChild,Sn=u&&s((function(){return 7!=dr(hn({},"a",{get:function(){return hn(this,"a",{value:7}).a}})).a}))?function(t,e,r){var n=fn(un,e);n&&delete un[e],hn(t,e,r),n&&t!==un&&hn(un,e,n)}:hn,kn=function(t,e){var r=yn[t]=dr(cn.prototype);return on(r,{type:"Symbol",tag:t,description:e}),u||(r.description=e),r},On=st?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof cn},Dn=function(t,e,r){t===un&&Dn(vn,e,r),F(t);var n=w(e,!0);return F(r),S(yn,n)?(r.enumerable?(S(t,nn)&&t[nn][n]&&(t[nn][n]=!1),r=dr(r,{enumerable:h(0,!1)})):(S(t,nn)||hn(t,nn,h(1,{})),t[nn][n]=!0),Sn(t,n,r)):hn(t,n,r)},xn=function(t,e){F(t);var r=g(e),n=xe(r).concat(Pn(r));return rn(n,(function(e){u&&!Mn.call(r,e)||Dn(t,e,r[e])})),t},Mn=function(t){var e=w(t,!0),r=pn.call(this,e);return!(this===un&&S(yn,e)&&!S(vn,e))&&(!(r||!S(this,e)||!S(yn,e)||S(this,nn)&&this[nn][e])||r)},Yn=function(t,e){var r=g(t),n=w(e,!0);if(r!==un||!S(yn,n)||S(vn,n)){var i=fn(r,n);return!i||!S(yn,n)||S(r,nn)&&r[nn][n]||(i.enumerable=!0),i}},Tn=function(t){var e=dn(g(t)),r=[];return rn(e,(function(t){S(yn,t)||S(Se,t)||r.push(t)})),r},Pn=function(t){var e=t===un,r=dn(e?vn:g(t)),n=[];return rn(r,(function(t){!S(yn,t)||e&&!S(un,t)||n.push(yn[t])})),n};if(ot||(xr((cn=function(){if(this instanceof cn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=at(t),r=function(t){this===un&&r.call(vn,t),S(this,nn)&&S(this[nn],e)&&(this[nn][e]=!1),Sn(this,e,h(1,t))};return u&&bn&&Sn(un,e,{configurable:!0,set:r}),kn(e,t)}).prototype,"toString",(function(){return sn(this).tag})),xr(cn,"withoutSetter",(function(t){return kn(at(t),t)})),f.f=Mn,U.f=Dn,Y.f=Yn,Pe.f=Kr.f=Tn,je.f=Pn,Xr.f=function(t){return kn(ft(t),t)},u&&hn(cn.prototype,"description",{configurable:!0,get:function(){return sn(this).description}})),z({global:!0,wrap:!0,forced:!ot,sham:!ot},{Symbol:cn}),rn(xe(_n),(function(t){en(t)})),z({target:"Symbol",stat:!0,forced:!ot},{for:function(t){var e=String(t);if(S(mn,e))return mn[e];var r=cn(e);return mn[e]=r,gn[r]=e,r},keyFor:function(t){if(!On(t))throw TypeError(t+" is not a symbol");if(S(gn,t))return gn[t]},useSetter:function(){bn=!0},useSimple:function(){bn=!1}}),z({target:"Object",stat:!0,forced:!ot,sham:!u},{create:function(t,e){return void 0===e?dr(t):xn(dr(t),e)},defineProperty:Dn,defineProperties:xn,getOwnPropertyDescriptor:Yn}),z({target:"Object",stat:!0,forced:!ot},{getOwnPropertyNames:Tn,getOwnPropertySymbols:Pn}),z({target:"Object",stat:!0,forced:s((function(){je.f(1)}))},{getOwnPropertySymbols:function(t){return je.f(tt(t))}}),ln){var jn=!ot||s((function(){var t=cn();return"[null]"!=ln([t])||"{}"!=ln({a:t})||"{}"!=ln(Object(t))}));z({target:"JSON",stat:!0,forced:jn},{stringify:function(t,e,r){for(var n,i=[t],a=1;arguments.length>a;)i.push(arguments[a++]);if(n=e,(_(e)||void 0!==t)&&!On(t))return q(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!On(e))return e}),i[1]=e,ln.apply(null,i)}})}cn.prototype[an]||H(cn.prototype,an,cn.prototype.valueOf),Sr(cn,"Symbol"),Se[nn]=!0;var An=C.Object.getOwnPropertySymbols,Nn=function(t){return function(e,r){var n,i,a=String(m(e)),o=B(r),s=a.length;return o<0||o>=s?t?"":void 0:(n=a.charCodeAt(o))<55296||n>56319||o+1===s||(i=a.charCodeAt(o+1))<56320||i>57343?t?a.charAt(o):n:t?a.slice(o,o+2):i-56320+(n-55296<<10)+65536}},En={codeAt:Nn(!1),charAt:Nn(!0)}.charAt,In=tr.set,Cn=tr.getterFor("String Iterator");jr(String,"String",(function(t){In(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Cn(this),r=e.string,n=e.index;return n>=r.length?{value:void 0,done:!0}:(t=En(r,n),e.index+=t.length,{value:t,done:!1})}));var Rn=ft("iterator"),Ln=function(t){if(null!=t)return t[Rn]||t["@@iterator"]||Ie[gr(t)]},Fn=function(t){var e=Ln(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return F(e.call(t))},Wn=Ln,Un=ft("isConcatSpreadable"),Hn=Tt>=51||!s((function(){var t=[];return t[Un]=!1,t.concat()[0]!==t})),Gn=jt("concat"),Vn=function(t){if(!_(t))return!1;var e=t[Un];return void 0!==e?!!e:q(t)};z({target:"Array",proto:!0,forced:!Hn||!Gn},{concat:function(t){var e,r,n,i,a,o=tt(this),s=dt(o,0),u=0;for(e=-1,n=arguments.length;e<n;e++)if(Vn(a=-1===e?o:arguments[e])){if(u+(i=Q(a.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<i;r++,u++)r in a&&Ne(s,u,a[r])}else{if(u>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Ne(s,u++,a)}return s.length=u,s}});var zn=Object.freeze({__proto__:null});en("asyncIterator");var qn=Object.freeze({__proto__:null});en("hasInstance"),en("isConcatSpreadable"),en("iterator"),en("match"),en("matchAll"),en("replace"),en("search"),en("species"),en("split"),en("toPrimitive"),en("toStringTag"),en("unscopables"),Sr(Math,"Math",!0),Sr(o.JSON,"JSON",!0),n(zn),n(qn);var Zn=C.Symbol,$n=Zn,Bn=function(t,e,r,n){try{return n?e(F(r)[0],r[1]):e(r)}catch(e){var i=t.return;throw void 0!==i&&F(i.call(t)),e}},Jn=ft("iterator"),Qn=Array.prototype,Kn=function(t){return void 0!==t&&(Ie.Array===t||Qn[Jn]===t)},Xn=ft("iterator"),ti=!1;try{var ei=0,ri={next:function(){return{done:!!ei++}},return:function(){ti=!0}};ri[Xn]=function(){return this},Array.from(ri,(function(){throw 2}))}catch(t){}var ni=!function(t,e){if(!e&&!ti)return!1;var r=!1;try{var n={};n[Xn]=function(){return{next:function(){return{done:r=!0}}}},t(n)}catch(t){}return r}((function(t){Array.from(t)}));z({target:"Array",stat:!0,forced:ni},{from:function(t){var e,r,n,i,a,o,s=tt(t),u="function"==typeof this?this:Array,c=arguments.length,l=c>1?arguments[1]:void 0,f=void 0!==l,h=Ln(s),d=0;if(f&&(l=L(l,c>2?arguments[2]:void 0,2)),null==h||u==Array&&Kn(h))for(r=new u(e=Q(s.length));e>d;d++)o=f?l(s[d],d):s[d],Ne(r,d,o);else for(a=(i=h.call(s)).next,r=new u;!(n=a.call(i)).done;d++)o=f?Bn(i,l,[n.value,d],!0):n.value,Ne(r,d,o);return r.length=d,r}});var ii=C.Array.from,ai=ii,oi=jt("slice"),si=It("slice",{ACCESSORS:!0,0:0,1:2}),ui=ft("species"),ci=[].slice,li=Math.max;z({target:"Array",proto:!0,forced:!oi||!si},{slice:function(t,e){var r,n,i,a=g(this),o=Q(a.length),s=_e(t,o),u=_e(void 0===e?o:e,o);if(q(a)&&("function"!=typeof(r=a.constructor)||r!==Array&&!q(r.prototype)?_(r)&&null===(r=r[ui])&&(r=void 0):r=void 0,r===Array||void 0===r))return ci.call(a,s,u);for(n=new(void 0===r?Array:r)(li(u-s,0)),i=0;s<u;s++,i++)s in a&&Ne(n,i,a[s]);return n.length=i,n}});var fi=vt("Array").slice,hi=Array.prototype,di=function(t){var e=t.slice;return t===hi||t instanceof Array&&e===hi.slice?fi:e},pi=di,yi=Ot("Reflect","construct"),vi=s((function(){function t(){}return!(yi((function(){}),[],t)instanceof t)})),mi=!s((function(){yi((function(){}))})),gi=vi||mi;z({target:"Reflect",stat:!0,forced:gi,sham:gi},{construct:function(t,e){R(t),F(e);var r=arguments.length<3?t:R(arguments[2]);if(mi&&!vi)return yi(t,e,r);if(t==r){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(ae.apply(t,n))}var i=r.prototype,a=dr(_(i)?i:Object.prototype),o=Function.apply.call(t,a,e);return _(o)?o:a}});var _i=C.Reflect.construct,wi=vt("Array").entries,bi=Array.prototype,Si={DOMTokenList:!0,NodeList:!0},ki=function(t){var e=t.entries;return t===bi||t instanceof Array&&e===bi.entries||Si.hasOwnProperty(gr(t))?wi:e},Oi=r((function(t){var e=function(t){var e=Object.prototype,r=e.hasOwnProperty,n="function"==typeof Symbol?Symbol:{},i=n.iterator||"@@iterator",a=n.asyncIterator||"@@asyncIterator",o=n.toStringTag||"@@toStringTag";function s(t,e,r,n){var i=e&&e.prototype instanceof l?e:l,a=Object.create(i.prototype),o=new S(n||[]);return a._invoke=function(t,e,r){var n="suspendedStart";return function(i,a){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===i)throw a;return O()}for(r.method=i,r.arg=a;;){var o=r.delegate;if(o){var s=_(o,r);if(s){if(s===c)continue;return s}}if("next"===r.method)r.sent=r._sent=r.arg;else if("throw"===r.method){if("suspendedStart"===n)throw n="completed",r.arg;r.dispatchException(r.arg)}else"return"===r.method&&r.abrupt("return",r.arg);n="executing";var l=u(t,e,r);if("normal"===l.type){if(n=r.done?"completed":"suspendedYield",l.arg===c)continue;return{value:l.arg,done:r.done}}"throw"===l.type&&(n="completed",r.method="throw",r.arg=l.arg)}}}(t,r,o),a}function u(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var c={};function l(){}function f(){}function h(){}var d={};d[i]=function(){return this};var p=Object.getPrototypeOf,y=p&&p(p(k([])));y&&y!==e&&r.call(y,i)&&(d=y);var v=h.prototype=l.prototype=Object.create(d);function m(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function g(t,e){var n;this._invoke=function(i,a){function o(){return new e((function(n,o){!function n(i,a,o,s){var c=u(t[i],t,a);if("throw"!==c.type){var l=c.arg,f=l.value;return f&&"object"==typeof f&&r.call(f,"__await")?e.resolve(f.__await).then((function(t){n("next",t,o,s)}),(function(t){n("throw",t,o,s)})):e.resolve(f).then((function(t){l.value=t,o(l)}),(function(t){return n("throw",t,o,s)}))}s(c.arg)}(i,a,n,o)}))}return n=n?n.then(o,o):o()}}function _(t,e){var r=t.iterator[e.method];if(void 0===r){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=void 0,_(t,e),"throw"===e.method))return c;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return c}var n=u(r,t.iterator,e.arg);if("throw"===n.type)return e.method="throw",e.arg=n.arg,e.delegate=null,c;var i=n.arg;return i?i.done?(e[t.resultName]=i.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,c):i:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,c)}function w(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function b(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function S(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(w,this),this.reset(!0)}function k(t){if(t){var e=t[i];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var n=-1,a=function e(){for(;++n<t.length;)if(r.call(t,n))return e.value=t[n],e.done=!1,e;return e.value=void 0,e.done=!0,e};return a.next=a}}return{next:O}}function O(){return{value:void 0,done:!0}}return f.prototype=v.constructor=h,h.constructor=f,h[o]=f.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===f||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,h):(t.__proto__=h,o in t||(t[o]="GeneratorFunction")),t.prototype=Object.create(v),t},t.awrap=function(t){return{__await:t}},m(g.prototype),g.prototype[a]=function(){return this},t.AsyncIterator=g,t.async=function(e,r,n,i,a){void 0===a&&(a=Promise);var o=new g(s(e,r,n,i),a);return t.isGeneratorFunction(r)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},m(v),v[o]="Generator",v[i]=function(){return this},v.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var r in t)e.push(r);return e.reverse(),function r(){for(;e.length;){var n=e.pop();if(n in t)return r.value=n,r.done=!1,r}return r.done=!0,r}},t.values=k,S.prototype={constructor:S,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(b),!t)for(var e in this)"t"===e.charAt(0)&&r.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function n(r,n){return o.type="throw",o.arg=t,e.next=r,n&&(e.method="next",e.arg=void 0),!!n}for(var i=this.tryEntries.length-1;i>=0;--i){var a=this.tryEntries[i],o=a.completion;if("root"===a.tryLoc)return n("end");if(a.tryLoc<=this.prev){var s=r.call(a,"catchLoc"),u=r.call(a,"finallyLoc");if(s&&u){if(this.prev<a.catchLoc)return n(a.catchLoc,!0);if(this.prev<a.finallyLoc)return n(a.finallyLoc)}else if(s){if(this.prev<a.catchLoc)return n(a.catchLoc,!0)}else{if(!u)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return n(a.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var i=this.tryEntries[n];if(i.tryLoc<=this.prev&&r.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var a=i;break}}a&&("break"===t||"continue"===t)&&a.tryLoc<=e&&e<=a.finallyLoc&&(a=null);var o=a?a.completion:{};return o.type=t,o.arg=e,a?(this.method="next",this.next=a.finallyLoc,c):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),c},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),b(r),c}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var i=n.arg;b(r)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,r){return this.delegate={iterator:k(t),resultName:e,nextLoc:r},"next"===this.method&&(this.arg=void 0),c}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Di=Xr.f("iterator"),xi=Di,Mi=Ot("JSON","stringify"),Yi=/[\uD800-\uDFFF]/g,Ti=/^[\uD800-\uDBFF]$/,Pi=/^[\uDC00-\uDFFF]$/,ji=function(t,e,r){var n=r.charAt(e-1),i=r.charAt(e+1);return Ti.test(t)&&!Pi.test(i)||Pi.test(t)&&!Ti.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Ai=s((function(){return'"\\udf06\\ud834"'!==Mi("\udf06\ud834")||'"\\udead"'!==Mi("\udead")}));Mi&&z({target:"JSON",stat:!0,forced:Ai},{stringify:function(t,e,r){var n=Mi.apply(null,arguments);return"string"==typeof n?n.replace(Yi,ji):n}}),C.JSON||(C.JSON={stringify:JSON.stringify});var Ni=function(t,e,r){return C.JSON.stringify.apply(null,arguments)};var Ei=function(t,e,r){return e in t?fe(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},Ii=vt("Array").values,Ci=Array.prototype,Ri={DOMTokenList:!0,NodeList:!0},Li=function(t){var e=t.values;return t===Ci||t instanceof Array&&e===Ci.values||Ri.hasOwnProperty(gr(t))?Ii:e},Fi=[],Wi=Fi.sort,Ui=s((function(){Fi.sort(void 0)})),Hi=s((function(){Fi.sort(null)})),Gi=Bt("sort");z({target:"Array",proto:!0,forced:Ui||!Hi||!Gi},{sort:function(t){return void 0===t?Wi.call(tt(this)):Wi.call(tt(this),R(t))}});var Vi=vt("Array").sort,zi=Array.prototype,qi=function(t){var e=t.sort;return t===zi||t instanceof Array&&e===zi.sort?Vi:e},Zi=vt("Array").keys,$i=Array.prototype,Bi={DOMTokenList:!0,NodeList:!0},Ji=function(t){var e=t.keys;return t===$i||t instanceof Array&&e===$i.keys||Bi.hasOwnProperty(gr(t))?Zi:e};z({target:"Array",stat:!0},{isArray:q});var Qi=C.Array.isArray,Ki=Qi;var Xi=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n};var ta=function(t){if(Ki(t))return Xi(t)},ea=ii,ra=ft("iterator"),na=function(t){var e=Object(t);return void 0!==e[ra]||"@@iterator"in e||Ie.hasOwnProperty(gr(e))};en("asyncDispose"),en("dispose"),en("observable"),en("patternMatch"),en("replaceAll");var ia=Zn;var aa=function(t){if(void 0!==ia&&na(Object(t)))return ea(t)},oa=di;var sa=function(t,e){var r;if(t){if("string"==typeof t)return Xi(t,e);var n=oa(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?ea(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Xi(t,e):void 0}};var ua=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var ca=function(t){return ta(t)||aa(t)||sa(t)||ua()},la=vt("Array").concat,fa=Array.prototype,ha=function(t){var e=t.concat;return t===fa||t instanceof Array&&e===fa.concat?la:e},da=Object.assign,pa=Object.defineProperty,ya=!da||s((function(){if(u&&1!==da({b:1},da(pa({},"a",{enumerable:!0,get:function(){pa(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol();return t[r]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=da({},t)[r]||"abcdefghijklmnopqrst"!=xe(da({},e)).join("")}))?function(t,e){for(var r=tt(t),n=arguments.length,i=1,a=je.f,o=f.f;n>i;)for(var s,c=v(arguments[i++]),l=a?xe(c).concat(a(c)):xe(c),h=l.length,d=0;h>d;)s=l[d++],u&&!o.call(c,s)||(r[s]=c[s]);return r}:da;z({target:"Object",stat:!0,forced:Object.assign!==ya},{assign:ya});var va=C.Object.assign,ma=St.some,ga=Bt("some"),_a=It("some");z({target:"Array",proto:!0,forced:!ga||!_a},{some:function(t){return ma(this,t,arguments.length>1?arguments[1]:void 0)}});var wa=vt("Array").some,ba=Array.prototype,Sa=function(t){var e=t.some;return t===ba||t instanceof Array&&e===ba.some?wa:e},ka=Di,Oa=r((function(t){function e(r){return t.exports=e="function"==typeof ia&&"symbol"==typeof ka?function(t){return typeof t}:function(t){return t&&"function"==typeof ia&&t.constructor===ia&&t!==ia.prototype?"symbol":typeof t},e(r)}t.exports=e})),Da=s((function(){xe(1)}));z({target:"Object",stat:!0,forced:Da},{keys:function(t){return xe(tt(t))}});var xa=C.Object.keys,Ma=!s((function(){return Object.isExtensible(Object.preventExtensions({}))})),Ya=r((function(t){var e=U.f,r=at("meta"),n=0,i=Object.isExtensible||function(){return!0},a=function(t){e(t,r,{value:{objectID:"O"+ ++n,weakData:{}}})},o=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!_(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!S(t,r)){if(!i(t))return"F";if(!e)return"E";a(t)}return t[r].objectID},getWeakData:function(t,e){if(!S(t,r)){if(!i(t))return!0;if(!e)return!1;a(t)}return t[r].weakData},onFreeze:function(t){return Ma&&o.REQUIRED&&i(t)&&!S(t,r)&&a(t),t}};Se[r]=!0})),Ta=r((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,r,n,i,a){var o,s,u,c,l,f,h,d=L(r,n,i?2:1);if(a)o=t;else{if("function"!=typeof(s=Ln(t)))throw TypeError("Target is not iterable");if(Kn(s)){for(u=0,c=Q(t.length);c>u;u++)if((l=i?d(F(h=t[u])[0],h[1]):d(t[u]))&&l instanceof e)return l;return new e(!1)}o=s.call(t)}for(f=o.next;!(h=f.call(o)).done;)if("object"==typeof(l=Bn(o,d,h.value,i))&&l&&l instanceof e)return l;return new e(!1)}).stop=function(t){return new e(!0,t)}})),Pa=function(t,e,r){if(!(t instanceof e))throw TypeError("Incorrect "+(r?r+" ":"")+"invocation");return t},ja=U.f,Aa=St.forEach,Na=tr.set,Ea=tr.getterFor,Ia=function(t,e,r){var n,i=-1!==t.indexOf("Map"),a=-1!==t.indexOf("Weak"),c=i?"set":"add",l=o[t],f=l&&l.prototype,h={};if(u&&"function"==typeof l&&(a||f.forEach&&!s((function(){(new l).entries().next()})))){n=e((function(e,r){Na(Pa(e,n,t),{type:t,collection:new l}),null!=r&&Ta(r,e[c],e,i)}));var d=Ea(t);Aa(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in f)||a&&"clear"==t||H(n.prototype,t,(function(r,n){var i=d(this).collection;if(!e&&a&&!_(r))return"get"==t&&void 0;var o=i[t](0===r?0:r,n);return e?this:o}))})),a||ja(n.prototype,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else n=r.getConstructor(e,t,i,c),Ya.REQUIRED=!0;return Sr(n,t,!1,!0),h[t]=n,z({global:!0,forced:!0},h),a||r.setStrong(n,t,i),n},Ca=function(t,e,r){for(var n in e)r&&r.unsafe&&t[n]?t[n]=e[n]:xr(t,n,e[n],r);return t},Ra=ft("species"),La=U.f,Fa=Ya.fastKey,Wa=tr.set,Ua=tr.getterFor,Ha={getConstructor:function(t,e,r,n){var i=t((function(t,a){Pa(t,i,e),Wa(t,{type:e,index:dr(null),first:void 0,last:void 0,size:0}),u||(t.size=0),null!=a&&Ta(a,t[n],t,r)})),a=Ua(e),o=function(t,e,r){var n,i,o=a(t),c=s(t,e);return c?c.value=r:(o.last=c={index:i=Fa(e,!0),key:e,value:r,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=c),n&&(n.next=c),u?o.size++:t.size++,"F"!==i&&(o.index[i]=c)),t},s=function(t,e){var r,n=a(t),i=Fa(e);if("F"!==i)return n.index[i];for(r=n.first;r;r=r.next)if(r.key==e)return r};return Ca(i.prototype,{clear:function(){for(var t=a(this),e=t.index,r=t.first;r;)r.removed=!0,r.previous&&(r.previous=r.previous.next=void 0),delete e[r.index],r=r.next;t.first=t.last=void 0,u?t.size=0:this.size=0},delete:function(t){var e=a(this),r=s(this,t);if(r){var n=r.next,i=r.previous;delete e.index[r.index],r.removed=!0,i&&(i.next=n),n&&(n.previous=i),e.first==r&&(e.first=n),e.last==r&&(e.last=i),u?e.size--:this.size--}return!!r},forEach:function(t){for(var e,r=a(this),n=L(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:r.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),Ca(i.prototype,r?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return o(this,0===t?0:t,e)}}:{add:function(t){return o(this,t=0===t?0:t,t)}}),u&&La(i.prototype,"size",{get:function(){return a(this).size}}),i},setStrong:function(t,e,r){var n=e+" Iterator",i=Ua(e),a=Ua(n);jr(t,e,(function(t,e){Wa(this,{type:n,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=a(this),e=t.kind,r=t.last;r&&r.removed;)r=r.previous;return t.target&&(t.last=r=r?r.next:t.state.first)?"keys"==e?{value:r.key,done:!1}:"values"==e?{value:r.value,done:!1}:{value:[r.key,r.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),r?"entries":"values",!r,!0),function(t){var e=Ot(t),r=U.f;u&&e&&!e[Ra]&&r(e,Ra,{configurable:!0,get:function(){return this}})}(e)}},Ga=(Ia("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ha),C.Map),Va=Qi;z({target:"Object",stat:!0,sham:!u},{create:dr});var za=C.Object,qa=function(t,e){return za.create(t,e)},Za=qa;z({target:"Object",stat:!0},{setPrototypeOf:Dr});var $a=C.Object.setPrototypeOf,Ba=r((function(t){function e(r,n){return t.exports=e=$a||function(t,e){return t.__proto__=e,t},e(r,n)}t.exports=e}));var Ja=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Za(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Ba(t,e)};var Qa=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var Ka=function(t,e){return!e||"object"!==Oa(e)&&"function"!=typeof e?Qa(t):e},Xa=s((function(){ir(1)}));z({target:"Object",stat:!0,forced:Xa,sham:!er},{getPrototypeOf:function(t){return ir(tt(t))}});var to=C.Object.getPrototypeOf,eo=r((function(t){function e(r){return t.exports=e=$a?to:function(t){return t.__proto__||to(t)},e(r)}t.exports=e})),ro="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),no=new Uint8Array(16);function io(){if(!ro)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return ro(no)}for(var ao=[],oo=0;oo<256;++oo)ao.push((oo+256).toString(16).substr(1));function so(t,e,r){"string"==typeof t&&(e="binary"===t?new Uint8Array(16):null,t=null);var n=(t=t||{}).random||(t.rng||io)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){for(var i=r||0,a=0;a<16;++a)e[i+a]=n[a];return e}return function(t,e){var r=e||0,n=ao;return(n[t[r+0]]+n[t[r+1]]+n[t[r+2]]+n[t[r+3]]+"-"+n[t[r+4]]+n[t[r+5]]+"-"+n[t[r+6]]+n[t[r+7]]+"-"+n[t[r+8]]+n[t[r+9]]+"-"+n[t[r+10]]+n[t[r+11]]+n[t[r+12]]+n[t[r+13]]+n[t[r+14]]+n[t[r+15]]).toLowerCase()}(n)}var uo,co=qa,lo="\t\n\v\f\r                　\u2028\u2029\ufeff",fo="["+lo+"]",ho=RegExp("^"+fo+fo+"*"),po=RegExp(fo+fo+"*$"),yo=function(t){return function(e){var r=String(m(e));return 1&t&&(r=r.replace(ho,"")),2&t&&(r=r.replace(po,"")),r}},vo={start:yo(1),end:yo(2),trim:yo(3)},mo=vo.trim;z({target:"String",proto:!0,forced:(uo="trim",s((function(){return!!lo[uo]()||"​᠎"!="​᠎"[uo]()||lo[uo].name!==uo})))},{trim:function(){return mo(this)}});vt("String").trim;var go=vo.trim,_o=o.parseInt,wo=/^[+-]?0[Xx]/,bo=8!==_o(lo+"08")||22!==_o(lo+"0x16")?function(t,e){var r=go(String(t));return _o(r,e>>>0||(wo.test(r)?16:10))}:_o;z({global:!0,forced:parseInt!=bo},{parseInt:bo});var So=f.f,ko=function(t){return function(e){for(var r,n=g(e),i=xe(n),a=i.length,o=0,s=[];a>o;)r=i[o++],u&&!So.call(n,r)||s.push(t?[r,n[r]]:n[r]);return s}},Oo={entries:ko(!0),values:ko(!1)}.values;z({target:"Object",stat:!0},{values:function(t){return Oo(t)}});C.Object.values;var Do=be.indexOf,xo=[].indexOf,Mo=!!xo&&1/[1].indexOf(1,-0)<0,Yo=Bt("indexOf"),To=It("indexOf",{ACCESSORS:!0,1:0});z({target:"Array",proto:!0,forced:Mo||!Yo||!To},{indexOf:function(t){return Mo?xo.apply(this,arguments)||0:Do(this,t,arguments.length>1?arguments[1]:void 0)}});vt("Array").indexOf;var Po=function(t){if(Ki(t))return t};var jo=function(t,e){if(void 0!==ia&&na(Object(t))){var r=[],n=!0,i=!1,a=void 0;try{for(var o,s=Fn(t);!(n=(o=s.next()).done)&&(r.push(o.value),!e||r.length!==e);n=!0);}catch(t){i=!0,a=t}finally{try{n||null==s.return||s.return()}finally{if(i)throw a}}return r}};var Ao=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var No=function(t,e){return Po(t)||jo(t,e)||sa(t,e)||Ao()};z({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});C.Date.now;z({target:"Reflect",stat:!0},{ownKeys:Ae});var Eo=C.Reflect.ownKeys;function Io(t,e){var r;if(void 0===$n||null==Wn(t)){if(Va(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return Co(t,e);var n=pi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return ai(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Co(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,o=!0,s=!1;return{s:function(){r=Fn(t)},n:function(){var t=r.next();return o=t.done,t},e:function(t){s=!0,a=t},f:function(){try{o||null==r.return||r.return()}finally{if(s)throw a}}}}function Co(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.1
	 * @date    2020-06-15T12:58:12.015Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var Ro=$n("DELETE");function Lo(){var t=Fo.apply(void 0,arguments);return Uo(t),console.log(t),t}function Fo(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];if(e.length<2)return e[0];var n;if(e.length>2)return Fo.apply(void 0,ha(n=[Lo(e[0],e[1])]).call(n,ca(pi(e).call(e,2))));var i,a=e[0],o=e[1],s=Io(Eo(o));try{for(s.s();!(i=s.n()).done;){var u=i.value;Object.prototype.propertyIsEnumerable.call(o,o[u])||(o[u]===Ro?delete a[u]:null===a[u]||null===o[u]||"object"!==Oa(a[u])||"object"!==Oa(o[u])||Va(a[u])||Va(o[u])?a[u]=Wo(o[u]):a[u]=Fo(a[u],o[u]))}}catch(t){s.e(t)}finally{s.f()}return a}function Wo(t){return Va(t)?Ut(t).call(t,(function(t){return Wo(t)})):"object"===Oa(t)&&null!==t?Fo({},t):t}function Uo(t){for(var e=0,r=xa(t);e<r.length;e++){var n=r[e];t[n]===Ro?delete t[n]:"object"===Oa(t[n])&&null!==t[n]&&Uo(t[n])}}function Ho(t){return t instanceof Number||"number"==typeof t}function Go(t){return t instanceof String||"string"==typeof t}function Vo(t){var e=Oa(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Va(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}var zo=r((function(t,e){t.exports=function(){var e,r;function n(){return e.apply(null,arguments)}function a(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function o(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function s(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function u(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(s(t,e))return!1;return!0}function c(t){return void 0===t}function l(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function f(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function h(t,e){var r,n=[];for(r=0;r<t.length;++r)n.push(e(t[r],r));return n}function d(t,e){for(var r in e)s(e,r)&&(t[r]=e[r]);return s(e,"toString")&&(t.toString=e.toString),s(e,"valueOf")&&(t.valueOf=e.valueOf),t}function p(t,e,r,n){return De(t,e,r,n,!0).utc()}function y(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function v(t){if(null==t._isValid){var e=y(t),n=r.call(e.parsedDateParts,(function(t){return null!=t})),i=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n);if(t._strict&&(i=i&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return i;t._isValid=i}return t._isValid}function m(t){var e=p(NaN);return null!=t?d(y(e),t):y(e).userInvalidated=!0,e}r=Array.prototype.some?Array.prototype.some:function(t){var e,r=Object(this),n=r.length>>>0;for(e=0;e<n;e++)if(e in r&&t.call(this,r[e],e,r))return!0;return!1};var g=n.momentProperties=[],_=!1;function w(t,e){var r,n,i;if(c(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),c(e._i)||(t._i=e._i),c(e._f)||(t._f=e._f),c(e._l)||(t._l=e._l),c(e._strict)||(t._strict=e._strict),c(e._tzm)||(t._tzm=e._tzm),c(e._isUTC)||(t._isUTC=e._isUTC),c(e._offset)||(t._offset=e._offset),c(e._pf)||(t._pf=y(e)),c(e._locale)||(t._locale=e._locale),g.length>0)for(r=0;r<g.length;r++)c(i=e[n=g[r]])||(t[n]=i);return t}function b(t){w(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===_&&(_=!0,n.updateOffset(this),_=!1)}function S(t){return t instanceof b||null!=t&&null!=t._isAMomentObject}function k(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function O(t,e){var r=!0;return d((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),r){var i,a,o,u=[];for(a=0;a<arguments.length;a++){if(i="","object"==typeof arguments[a]){for(o in i+="\n["+a+"] ",arguments[0])s(arguments[0],o)&&(i+=o+": "+arguments[0][o]+", ");i=i.slice(0,-2)}else i=arguments[a];u.push(i)}k(t+"\nArguments: "+Array.prototype.slice.call(u).join("")+"\n"+(new Error).stack),r=!1}return e.apply(this,arguments)}),e)}var D,x={};function M(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),x[t]||(k(e),x[t]=!0)}function Y(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function T(t,e){var r,n=d({},t);for(r in e)s(e,r)&&(o(t[r])&&o(e[r])?(n[r]={},d(n[r],t[r]),d(n[r],e[r])):null!=e[r]?n[r]=e[r]:delete n[r]);for(r in t)s(t,r)&&!s(e,r)&&o(t[r])&&(n[r]=d({},n[r]));return n}function P(t){null!=t&&this.set(t)}function j(t,e,r){var n=""+Math.abs(t),i=e-n.length;return(t>=0?r?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+n}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,D=Object.keys?Object.keys:function(t){var e,r=[];for(e in t)s(t,e)&&r.push(e);return r};var A=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,N=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,E={},I={};function C(t,e,r,n){var i=n;"string"==typeof n&&(i=function(){return this[n]()}),t&&(I[t]=i),e&&(I[e[0]]=function(){return j(i.apply(this,arguments),e[1],e[2])}),r&&(I[r]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function R(t,e){return t.isValid()?(e=L(e,t.localeData()),E[e]=E[e]||function(t){var e,r,n,i=t.match(A);for(e=0,r=i.length;e<r;e++)I[i[e]]?i[e]=I[i[e]]:i[e]=(n=i[e]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(e){var n,a="";for(n=0;n<r;n++)a+=Y(i[n])?i[n].call(e,t):i[n];return a}}(e),E[e](t)):t.localeData().invalidDate()}function L(t,e){var r=5;function n(t){return e.longDateFormat(t)||t}for(N.lastIndex=0;r>=0&&N.test(t);)t=t.replace(N,n),N.lastIndex=0,r-=1;return t}var F={};function W(t,e){var r=t.toLowerCase();F[r]=F[r+"s"]=F[e]=t}function U(t){return"string"==typeof t?F[t]||F[t.toLowerCase()]:void 0}function H(t){var e,r,n={};for(r in t)s(t,r)&&(e=U(r))&&(n[e]=t[r]);return n}var G={};function V(t,e){G[t]=e}function z(t){return t%4==0&&t%100!=0||t%400==0}function q(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function Z(t){var e=+t,r=0;return 0!==e&&isFinite(e)&&(r=q(e)),r}function $(t,e){return function(r){return null!=r?(J(this,t,r),n.updateOffset(this,e),this):B(this,t)}}function B(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function J(t,e,r){t.isValid()&&!isNaN(r)&&("FullYear"===e&&z(t.year())&&1===t.month()&&29===t.date()?(r=Z(r),t._d["set"+(t._isUTC?"UTC":"")+e](r,t.month(),St(r,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](r))}var Q,K=/\d/,X=/\d\d/,tt=/\d{3}/,et=/\d{4}/,rt=/[+-]?\d{6}/,nt=/\d\d?/,it=/\d\d\d\d?/,at=/\d\d\d\d\d\d?/,ot=/\d{1,3}/,st=/\d{1,4}/,ut=/[+-]?\d{1,6}/,ct=/\d+/,lt=/[+-]?\d+/,ft=/Z|[+-]\d\d:?\d\d/gi,ht=/Z|[+-]\d\d(?::?\d\d)?/gi,dt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function pt(t,e,r){Q[t]=Y(e)?e:function(t,n){return t&&r?r:e}}function yt(t,e){return s(Q,t)?Q[t](e._strict,e._locale):new RegExp(vt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,r,n,i){return e||r||n||i}))))}function vt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}Q={};var mt,gt={};function _t(t,e){var r,n=e;for("string"==typeof t&&(t=[t]),l(e)&&(n=function(t,r){r[e]=Z(t)}),r=0;r<t.length;r++)gt[t[r]]=n}function wt(t,e){_t(t,(function(t,r,n,i){n._w=n._w||{},e(t,n._w,n,i)}))}function bt(t,e,r){null!=e&&s(gt,t)&&gt[t](e,r._a,r,t)}function St(t,e){if(isNaN(t)||isNaN(e))return NaN;var r,n=(e%(r=12)+r)%r;return t+=(e-n)/12,1===n?z(t)?29:28:31-n%7%2}mt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},C("M",["MM",2],"Mo",(function(){return this.month()+1})),C("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),C("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),W("month","M"),V("month",8),pt("M",nt),pt("MM",nt,X),pt("MMM",(function(t,e){return e.monthsShortRegex(t)})),pt("MMMM",(function(t,e){return e.monthsRegex(t)})),_t(["M","MM"],(function(t,e){e[1]=Z(t)-1})),_t(["MMM","MMMM"],(function(t,e,r,n){var i=r._locale.monthsParse(t,n,r._strict);null!=i?e[1]=i:y(r).invalidMonth=t}));var kt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Ot="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),Dt=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,xt=dt,Mt=dt;function Yt(t,e,r){var n,i,a,o=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)a=p([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(a,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(a,"").toLocaleLowerCase();return r?"MMM"===e?-1!==(i=mt.call(this._shortMonthsParse,o))?i:null:-1!==(i=mt.call(this._longMonthsParse,o))?i:null:"MMM"===e?-1!==(i=mt.call(this._shortMonthsParse,o))||-1!==(i=mt.call(this._longMonthsParse,o))?i:null:-1!==(i=mt.call(this._longMonthsParse,o))||-1!==(i=mt.call(this._shortMonthsParse,o))?i:null}function Tt(t,e){var r;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=Z(e);else if(!l(e=t.localeData().monthsParse(e)))return t;return r=Math.min(t.date(),St(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,r),t}function Pt(t){return null!=t?(Tt(this,t),n.updateOffset(this,!0),this):B(this,"Month")}function jt(){function t(t,e){return e.length-t.length}var e,r,n=[],i=[],a=[];for(e=0;e<12;e++)r=p([2e3,e]),n.push(this.monthsShort(r,"")),i.push(this.months(r,"")),a.push(this.months(r,"")),a.push(this.monthsShort(r,""));for(n.sort(t),i.sort(t),a.sort(t),e=0;e<12;e++)n[e]=vt(n[e]),i[e]=vt(i[e]);for(e=0;e<24;e++)a[e]=vt(a[e]);this._monthsRegex=new RegExp("^("+a.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function At(t){return z(t)?366:365}C("Y",0,0,(function(){var t=this.year();return t<=9999?j(t,4):"+"+t})),C(0,["YY",2],0,(function(){return this.year()%100})),C(0,["YYYY",4],0,"year"),C(0,["YYYYY",5],0,"year"),C(0,["YYYYYY",6,!0],0,"year"),W("year","y"),V("year",1),pt("Y",lt),pt("YY",nt,X),pt("YYYY",st,et),pt("YYYYY",ut,rt),pt("YYYYYY",ut,rt),_t(["YYYYY","YYYYYY"],0),_t("YYYY",(function(t,e){e[0]=2===t.length?n.parseTwoDigitYear(t):Z(t)})),_t("YY",(function(t,e){e[0]=n.parseTwoDigitYear(t)})),_t("Y",(function(t,e){e[0]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return Z(t)+(Z(t)>68?1900:2e3)};var Nt=$("FullYear",!0);function Et(t,e,r,n,i,a,o){var s;return t<100&&t>=0?(s=new Date(t+400,e,r,n,i,a,o),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,r,n,i,a,o),s}function It(t){var e,r;return t<100&&t>=0?((r=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,r)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function Ct(t,e,r){var n=7+e-r;return-(7+It(t,0,n).getUTCDay()-e)%7+n-1}function Rt(t,e,r,n,i){var a,o,s=1+7*(e-1)+(7+r-n)%7+Ct(t,n,i);return s<=0?o=At(a=t-1)+s:s>At(t)?(a=t+1,o=s-At(t)):(a=t,o=s),{year:a,dayOfYear:o}}function Lt(t,e,r){var n,i,a=Ct(t.year(),e,r),o=Math.floor((t.dayOfYear()-a-1)/7)+1;return o<1?n=o+Ft(i=t.year()-1,e,r):o>Ft(t.year(),e,r)?(n=o-Ft(t.year(),e,r),i=t.year()+1):(i=t.year(),n=o),{week:n,year:i}}function Ft(t,e,r){var n=Ct(t,e,r),i=Ct(t+1,e,r);return(At(t)-n+i)/7}function Wt(t,e){return t.slice(e,7).concat(t.slice(0,e))}C("w",["ww",2],"wo","week"),C("W",["WW",2],"Wo","isoWeek"),W("week","w"),W("isoWeek","W"),V("week",5),V("isoWeek",5),pt("w",nt),pt("ww",nt,X),pt("W",nt),pt("WW",nt,X),wt(["w","ww","W","WW"],(function(t,e,r,n){e[n.substr(0,1)]=Z(t)})),C("d",0,"do","day"),C("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),C("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),C("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),C("e",0,0,"weekday"),C("E",0,0,"isoWeekday"),W("day","d"),W("weekday","e"),W("isoWeekday","E"),V("day",11),V("weekday",11),V("isoWeekday",11),pt("d",nt),pt("e",nt),pt("E",nt),pt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),pt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),pt("dddd",(function(t,e){return e.weekdaysRegex(t)})),wt(["dd","ddd","dddd"],(function(t,e,r,n){var i=r._locale.weekdaysParse(t,n,r._strict);null!=i?e.d=i:y(r).invalidWeekday=t})),wt(["d","e","E"],(function(t,e,r,n){e[n]=Z(t)}));var Ut="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ht="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Gt="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Vt=dt,zt=dt,qt=dt;function Zt(t,e,r){var n,i,a,o=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)a=p([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(a,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(a,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(a,"").toLocaleLowerCase();return r?"dddd"===e?-1!==(i=mt.call(this._weekdaysParse,o))?i:null:"ddd"===e?-1!==(i=mt.call(this._shortWeekdaysParse,o))?i:null:-1!==(i=mt.call(this._minWeekdaysParse,o))?i:null:"dddd"===e?-1!==(i=mt.call(this._weekdaysParse,o))||-1!==(i=mt.call(this._shortWeekdaysParse,o))||-1!==(i=mt.call(this._minWeekdaysParse,o))?i:null:"ddd"===e?-1!==(i=mt.call(this._shortWeekdaysParse,o))||-1!==(i=mt.call(this._weekdaysParse,o))||-1!==(i=mt.call(this._minWeekdaysParse,o))?i:null:-1!==(i=mt.call(this._minWeekdaysParse,o))||-1!==(i=mt.call(this._weekdaysParse,o))||-1!==(i=mt.call(this._shortWeekdaysParse,o))?i:null}function $t(){function t(t,e){return e.length-t.length}var e,r,n,i,a,o=[],s=[],u=[],c=[];for(e=0;e<7;e++)r=p([2e3,1]).day(e),n=vt(this.weekdaysMin(r,"")),i=vt(this.weekdaysShort(r,"")),a=vt(this.weekdays(r,"")),o.push(n),s.push(i),u.push(a),c.push(n),c.push(i),c.push(a);o.sort(t),s.sort(t),u.sort(t),c.sort(t),this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+o.join("|")+")","i")}function Bt(){return this.hours()%12||12}function Jt(t,e){C(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function Qt(t,e){return e._meridiemParse}C("H",["HH",2],0,"hour"),C("h",["hh",2],0,Bt),C("k",["kk",2],0,(function(){return this.hours()||24})),C("hmm",0,0,(function(){return""+Bt.apply(this)+j(this.minutes(),2)})),C("hmmss",0,0,(function(){return""+Bt.apply(this)+j(this.minutes(),2)+j(this.seconds(),2)})),C("Hmm",0,0,(function(){return""+this.hours()+j(this.minutes(),2)})),C("Hmmss",0,0,(function(){return""+this.hours()+j(this.minutes(),2)+j(this.seconds(),2)})),Jt("a",!0),Jt("A",!1),W("hour","h"),V("hour",13),pt("a",Qt),pt("A",Qt),pt("H",nt),pt("h",nt),pt("k",nt),pt("HH",nt,X),pt("hh",nt,X),pt("kk",nt,X),pt("hmm",it),pt("hmmss",at),pt("Hmm",it),pt("Hmmss",at),_t(["H","HH"],3),_t(["k","kk"],(function(t,e,r){var n=Z(t);e[3]=24===n?0:n})),_t(["a","A"],(function(t,e,r){r._isPm=r._locale.isPM(t),r._meridiem=t})),_t(["h","hh"],(function(t,e,r){e[3]=Z(t),y(r).bigHour=!0})),_t("hmm",(function(t,e,r){var n=t.length-2;e[3]=Z(t.substr(0,n)),e[4]=Z(t.substr(n)),y(r).bigHour=!0})),_t("hmmss",(function(t,e,r){var n=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,n)),e[4]=Z(t.substr(n,2)),e[5]=Z(t.substr(i)),y(r).bigHour=!0})),_t("Hmm",(function(t,e,r){var n=t.length-2;e[3]=Z(t.substr(0,n)),e[4]=Z(t.substr(n))})),_t("Hmmss",(function(t,e,r){var n=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,n)),e[4]=Z(t.substr(n,2)),e[5]=Z(t.substr(i))}));var Kt,Xt=$("Hours",!0),te={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:kt,monthsShort:Ot,week:{dow:0,doy:6},weekdays:Ut,weekdaysMin:Gt,weekdaysShort:Ht,meridiemParse:/[ap]\.?m?\.?/i},ee={},re={};function ne(t,e){var r,n=Math.min(t.length,e.length);for(r=0;r<n;r+=1)if(t[r]!==e[r])return r;return n}function ie(t){return t?t.toLowerCase().replace("_","-"):t}function ae(e){var r=null;if(void 0===ee[e]&&t&&t.exports)try{r=Kt._abbr,i(),oe(r)}catch(t){ee[e]=null}return ee[e]}function oe(t,e){var r;return t&&((r=c(e)?ue(t):se(t,e))?Kt=r:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),Kt._abbr}function se(t,e){if(null!==e){var r,n=te;if(e.abbr=t,null!=ee[t])M("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=ee[t]._config;else if(null!=e.parentLocale)if(null!=ee[e.parentLocale])n=ee[e.parentLocale]._config;else{if(null==(r=ae(e.parentLocale)))return re[e.parentLocale]||(re[e.parentLocale]=[]),re[e.parentLocale].push({name:t,config:e}),null;n=r._config}return ee[t]=new P(T(n,e)),re[t]&&re[t].forEach((function(t){se(t.name,t.config)})),oe(t),ee[t]}return delete ee[t],null}function ue(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return Kt;if(!a(t)){if(e=ae(t))return e;t=[t]}return function(t){for(var e,r,n,i,a=0;a<t.length;){for(e=(i=ie(t[a]).split("-")).length,r=(r=ie(t[a+1]))?r.split("-"):null;e>0;){if(n=ae(i.slice(0,e).join("-")))return n;if(r&&r.length>=e&&ne(i,r)>=e-1)break;e--}a++}return Kt}(t)}function ce(t){var e,r=t._a;return r&&-2===y(t).overflow&&(e=r[1]<0||r[1]>11?1:r[2]<1||r[2]>St(r[0],r[1])?2:r[3]<0||r[3]>24||24===r[3]&&(0!==r[4]||0!==r[5]||0!==r[6])?3:r[4]<0||r[4]>59?4:r[5]<0||r[5]>59?5:r[6]<0||r[6]>999?6:-1,y(t)._overflowDayOfYear&&(e<0||e>2)&&(e=2),y(t)._overflowWeeks&&-1===e&&(e=7),y(t)._overflowWeekday&&-1===e&&(e=8),y(t).overflow=e),t}var le=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,fe=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,he=/Z|[+-]\d\d(?::?\d\d)?/,de=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],pe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ye=/^\/?Date\((-?\d+)/i,ve=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,me={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function ge(t){var e,r,n,i,a,o,s=t._i,u=le.exec(s)||fe.exec(s);if(u){for(y(t).iso=!0,e=0,r=de.length;e<r;e++)if(de[e][1].exec(u[1])){i=de[e][0],n=!1!==de[e][2];break}if(null==i)return void(t._isValid=!1);if(u[3]){for(e=0,r=pe.length;e<r;e++)if(pe[e][1].exec(u[3])){a=(u[2]||" ")+pe[e][0];break}if(null==a)return void(t._isValid=!1)}if(!n&&null!=a)return void(t._isValid=!1);if(u[4]){if(!he.exec(u[4]))return void(t._isValid=!1);o="Z"}t._f=i+(a||"")+(o||""),ke(t)}else t._isValid=!1}function _e(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function we(t){var e,r,n,i,a,o,s,u,c=ve.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(c){if(r=c[4],n=c[3],i=c[2],a=c[5],o=c[6],s=c[7],u=[_e(r),Ot.indexOf(n),parseInt(i,10),parseInt(a,10),parseInt(o,10)],s&&u.push(parseInt(s,10)),e=u,!function(t,e,r){return!t||Ht.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(y(r).weekdayMismatch=!0,r._isValid=!1,!1)}(c[1],e,t))return;t._a=e,t._tzm=function(t,e,r){if(t)return me[t];if(e)return 0;var n=parseInt(r,10),i=n%100;return(n-i)/100*60+i}(c[8],c[9],c[10]),t._d=It.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),y(t).rfc2822=!0}else t._isValid=!1}function be(t,e,r){return null!=t?t:null!=e?e:r}function Se(t){var e,r,i,a,o,s=[];if(!t._d){for(i=function(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[2]&&null==t._a[1]&&function(t){var e,r,n,i,a,o,s,u,c;null!=(e=t._w).GG||null!=e.W||null!=e.E?(a=1,o=4,r=be(e.GG,t._a[0],Lt(xe(),1,4).year),n=be(e.W,1),((i=be(e.E,1))<1||i>7)&&(u=!0)):(a=t._locale._week.dow,o=t._locale._week.doy,c=Lt(xe(),a,o),r=be(e.gg,t._a[0],c.year),n=be(e.w,c.week),null!=e.d?((i=e.d)<0||i>6)&&(u=!0):null!=e.e?(i=e.e+a,(e.e<0||e.e>6)&&(u=!0)):i=a),n<1||n>Ft(r,a,o)?y(t)._overflowWeeks=!0:null!=u?y(t)._overflowWeekday=!0:(s=Rt(r,n,i,a,o),t._a[0]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(o=be(t._a[0],i[0]),(t._dayOfYear>At(o)||0===t._dayOfYear)&&(y(t)._overflowDayOfYear=!0),r=It(o,0,t._dayOfYear),t._a[1]=r.getUTCMonth(),t._a[2]=r.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=i[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[3]&&0===t._a[4]&&0===t._a[5]&&0===t._a[6]&&(t._nextDay=!0,t._a[3]=0),t._d=(t._useUTC?It:Et).apply(null,s),a=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[3]=24),t._w&&void 0!==t._w.d&&t._w.d!==a&&(y(t).weekdayMismatch=!0)}}function ke(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],y(t).empty=!0;var e,r,i,a,o,s,u=""+t._i,c=u.length,l=0;for(i=L(t._f,t._locale).match(A)||[],e=0;e<i.length;e++)a=i[e],(r=(u.match(yt(a,t))||[])[0])&&((o=u.substr(0,u.indexOf(r))).length>0&&y(t).unusedInput.push(o),u=u.slice(u.indexOf(r)+r.length),l+=r.length),I[a]?(r?y(t).empty=!1:y(t).unusedTokens.push(a),bt(a,r,t)):t._strict&&!r&&y(t).unusedTokens.push(a);y(t).charsLeftOver=c-l,u.length>0&&y(t).unusedInput.push(u),t._a[3]<=12&&!0===y(t).bigHour&&t._a[3]>0&&(y(t).bigHour=void 0),y(t).parsedDateParts=t._a.slice(0),y(t).meridiem=t._meridiem,t._a[3]=function(t,e,r){var n;return null==r?e:null!=t.meridiemHour?t.meridiemHour(e,r):null!=t.isPM?((n=t.isPM(r))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}(t._locale,t._a[3],t._meridiem),null!==(s=y(t).era)&&(t._a[0]=t._locale.erasConvertYear(s,t._a[0])),Se(t),ce(t)}else we(t);else ge(t)}function Oe(t){var e=t._i,r=t._f;return t._locale=t._locale||ue(t._l),null===e||void 0===r&&""===e?m({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),S(e)?new b(ce(e)):(f(e)?t._d=e:a(r)?function(t){var e,r,n,i,a,o,s=!1;if(0===t._f.length)return y(t).invalidFormat=!0,void(t._d=new Date(NaN));for(i=0;i<t._f.length;i++)a=0,o=!1,e=w({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],ke(e),v(e)&&(o=!0),a+=y(e).charsLeftOver,a+=10*y(e).unusedTokens.length,y(e).score=a,s?a<n&&(n=a,r=e):(null==n||a<n||o)&&(n=a,r=e,o&&(s=!0));d(t,r||e)}(t):r?ke(t):function(t){var e=t._i;c(e)?t._d=new Date(n.now()):f(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ye.exec(t._i);null===e?(ge(t),!1===t._isValid&&(delete t._isValid,we(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:n.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):a(e)?(t._a=h(e.slice(0),(function(t){return parseInt(t,10)})),Se(t)):o(e)?function(t){if(!t._d){var e=H(t._i),r=void 0===e.day?e.date:e.day;t._a=h([e.year,e.month,r,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),Se(t)}}(t):l(e)?t._d=new Date(e):n.createFromInputFallback(t)}(t),v(t)||(t._d=null),t))}function De(t,e,r,n,i){var s,c={};return!0!==e&&!1!==e||(n=e,e=void 0),!0!==r&&!1!==r||(n=r,r=void 0),(o(t)&&u(t)||a(t)&&0===t.length)&&(t=void 0),c._isAMomentObject=!0,c._useUTC=c._isUTC=i,c._l=r,c._i=t,c._f=e,c._strict=n,(s=new b(ce(Oe(c))))._nextDay&&(s.add(1,"d"),s._nextDay=void 0),s}function xe(t,e,r,n){return De(t,e,r,n,!1)}n.createFromInputFallback=O("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Me=O("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=xe.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:m()})),Ye=O("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=xe.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:m()}));function Te(t,e){var r,n;if(1===e.length&&a(e[0])&&(e=e[0]),!e.length)return xe();for(r=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](r)||(r=e[n]);return r}var Pe=["year","quarter","month","week","day","hour","minute","second","millisecond"];function je(t){var e=H(t),r=e.year||0,n=e.quarter||0,i=e.month||0,a=e.week||e.isoWeek||0,o=e.day||0,u=e.hour||0,c=e.minute||0,l=e.second||0,f=e.millisecond||0;this._isValid=function(t){var e,r,n=!1;for(e in t)if(s(t,e)&&(-1===mt.call(Pe,e)||null!=t[e]&&isNaN(t[e])))return!1;for(r=0;r<Pe.length;++r)if(t[Pe[r]]){if(n)return!1;parseFloat(t[Pe[r]])!==Z(t[Pe[r]])&&(n=!0)}return!0}(e),this._milliseconds=+f+1e3*l+6e4*c+1e3*u*60*60,this._days=+o+7*a,this._months=+i+3*n+12*r,this._data={},this._locale=ue(),this._bubble()}function Ae(t){return t instanceof je}function Ne(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Ee(t,e){C(t,0,0,(function(){var t=this.utcOffset(),r="+";return t<0&&(t=-t,r="-"),r+j(~~(t/60),2)+e+j(~~t%60,2)}))}Ee("Z",":"),Ee("ZZ",""),pt("Z",ht),pt("ZZ",ht),_t(["Z","ZZ"],(function(t,e,r){r._useUTC=!0,r._tzm=Ce(ht,t)}));var Ie=/([\+\-]|\d\d)/gi;function Ce(t,e){var r,n,i=(e||"").match(t);return null===i?null:0===(n=60*(r=((i[i.length-1]||[])+"").match(Ie)||["-",0,0])[1]+Z(r[2]))?0:"+"===r[0]?n:-n}function Re(t,e){var r,i;return e._isUTC?(r=e.clone(),i=(S(t)||f(t)?t.valueOf():xe(t).valueOf())-r.valueOf(),r._d.setTime(r._d.valueOf()+i),n.updateOffset(r,!1),r):xe(t).local()}function Le(t){return-Math.round(t._d.getTimezoneOffset())}function Fe(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var We=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Ue=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function He(t,e){var r,n,i,a,o,u,c=t,f=null;return Ae(t)?c={ms:t._milliseconds,d:t._days,M:t._months}:l(t)||!isNaN(+t)?(c={},e?c[e]=+t:c.milliseconds=+t):(f=We.exec(t))?(r="-"===f[1]?-1:1,c={y:0,d:Z(f[2])*r,h:Z(f[3])*r,m:Z(f[4])*r,s:Z(f[5])*r,ms:Z(Ne(1e3*f[6]))*r}):(f=Ue.exec(t))?(r="-"===f[1]?-1:1,c={y:Ge(f[2],r),M:Ge(f[3],r),w:Ge(f[4],r),d:Ge(f[5],r),h:Ge(f[6],r),m:Ge(f[7],r),s:Ge(f[8],r)}):null==c?c={}:"object"==typeof c&&("from"in c||"to"in c)&&(a=xe(c.from),o=xe(c.to),i=a.isValid()&&o.isValid()?(o=Re(o,a),a.isBefore(o)?u=Ve(a,o):((u=Ve(o,a)).milliseconds=-u.milliseconds,u.months=-u.months),u):{milliseconds:0,months:0},(c={}).ms=i.milliseconds,c.M=i.months),n=new je(c),Ae(t)&&s(t,"_locale")&&(n._locale=t._locale),Ae(t)&&s(t,"_isValid")&&(n._isValid=t._isValid),n}function Ge(t,e){var r=t&&parseFloat(t.replace(",","."));return(isNaN(r)?0:r)*e}function Ve(t,e){var r={};return r.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(r.months,"M").isAfter(e)&&--r.months,r.milliseconds=+e-+t.clone().add(r.months,"M"),r}function ze(t,e){return function(r,n){var i;return null===n||isNaN(+n)||(M(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),i=r,r=n,n=i),qe(this,He(r,n),t),this}}function qe(t,e,r,i){var a=e._milliseconds,o=Ne(e._days),s=Ne(e._months);t.isValid()&&(i=null==i||i,s&&Tt(t,B(t,"Month")+s*r),o&&J(t,"Date",B(t,"Date")+o*r),a&&t._d.setTime(t._d.valueOf()+a*r),i&&n.updateOffset(t,o||s))}He.fn=je.prototype,He.invalid=function(){return He(NaN)};var Ze=ze(1,"add"),$e=ze(-1,"subtract");function Be(t){return"string"==typeof t||t instanceof String}function Je(t){return S(t)||f(t)||Be(t)||l(t)||function(t){var e=a(t),r=!1;return e&&(r=0===t.filter((function(e){return!l(e)&&Be(t)})).length),e&&r}(t)||function(t){var e,r,n=o(t)&&!u(t),i=!1,a=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"];for(e=0;e<a.length;e+=1)r=a[e],i=i||s(t,r);return n&&i}(t)||null==t}function Qe(t){var e,r=o(t)&&!u(t),n=!1,i=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<i.length;e+=1)n=n||s(t,i[e]);return r&&n}function Ke(t,e){if(t.date()<e.date())return-Ke(e,t);var r=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(r,"months");return-(r+(e-n<0?(e-n)/(n-t.clone().add(r-1,"months")):(e-n)/(t.clone().add(r+1,"months")-n)))||0}function Xe(t){var e;return void 0===t?this._locale._abbr:(null!=(e=ue(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var tr=O("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function er(){return this._locale}function rr(t,e){return(t%e+e)%e}function nr(t,e,r){return t<100&&t>=0?new Date(t+400,e,r)-126227808e5:new Date(t,e,r).valueOf()}function ir(t,e,r){return t<100&&t>=0?Date.UTC(t+400,e,r)-126227808e5:Date.UTC(t,e,r)}function ar(t,e){return e.erasAbbrRegex(t)}function or(){var t,e,r=[],n=[],i=[],a=[],o=this.eras();for(t=0,e=o.length;t<e;++t)n.push(vt(o[t].name)),r.push(vt(o[t].abbr)),i.push(vt(o[t].narrow)),a.push(vt(o[t].name)),a.push(vt(o[t].abbr)),a.push(vt(o[t].narrow));this._erasRegex=new RegExp("^("+a.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+n.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+r.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+i.join("|")+")","i")}function sr(t,e){C(0,[t,t.length],0,e)}function ur(t,e,r,n,i){var a;return null==t?Lt(this,n,i).year:(e>(a=Ft(t,n,i))&&(e=a),cr.call(this,t,e,r,n,i))}function cr(t,e,r,n,i){var a=Rt(t,e,r,n,i),o=It(a.year,0,a.dayOfYear);return this.year(o.getUTCFullYear()),this.month(o.getUTCMonth()),this.date(o.getUTCDate()),this}C("N",0,0,"eraAbbr"),C("NN",0,0,"eraAbbr"),C("NNN",0,0,"eraAbbr"),C("NNNN",0,0,"eraName"),C("NNNNN",0,0,"eraNarrow"),C("y",["y",1],"yo","eraYear"),C("y",["yy",2],0,"eraYear"),C("y",["yyy",3],0,"eraYear"),C("y",["yyyy",4],0,"eraYear"),pt("N",ar),pt("NN",ar),pt("NNN",ar),pt("NNNN",(function(t,e){return e.erasNameRegex(t)})),pt("NNNNN",(function(t,e){return e.erasNarrowRegex(t)})),_t(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,r,n){var i=r._locale.erasParse(t,n,r._strict);i?y(r).era=i:y(r).invalidEra=t})),pt("y",ct),pt("yy",ct),pt("yyy",ct),pt("yyyy",ct),pt("yo",(function(t,e){return e._eraYearOrdinalRegex||ct})),_t(["y","yy","yyy","yyyy"],0),_t(["yo"],(function(t,e,r,n){var i;r._locale._eraYearOrdinalRegex&&(i=t.match(r._locale._eraYearOrdinalRegex)),r._locale.eraYearOrdinalParse?e[0]=r._locale.eraYearOrdinalParse(t,i):e[0]=parseInt(t,10)})),C(0,["gg",2],0,(function(){return this.weekYear()%100})),C(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),sr("gggg","weekYear"),sr("ggggg","weekYear"),sr("GGGG","isoWeekYear"),sr("GGGGG","isoWeekYear"),W("weekYear","gg"),W("isoWeekYear","GG"),V("weekYear",1),V("isoWeekYear",1),pt("G",lt),pt("g",lt),pt("GG",nt,X),pt("gg",nt,X),pt("GGGG",st,et),pt("gggg",st,et),pt("GGGGG",ut,rt),pt("ggggg",ut,rt),wt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,r,n){e[n.substr(0,2)]=Z(t)})),wt(["gg","GG"],(function(t,e,r,i){e[i]=n.parseTwoDigitYear(t)})),C("Q",0,"Qo","quarter"),W("quarter","Q"),V("quarter",7),pt("Q",K),_t("Q",(function(t,e){e[1]=3*(Z(t)-1)})),C("D",["DD",2],"Do","date"),W("date","D"),V("date",9),pt("D",nt),pt("DD",nt,X),pt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),_t(["D","DD"],2),_t("Do",(function(t,e){e[2]=Z(t.match(nt)[0])}));var lr=$("Date",!0);C("DDD",["DDDD",3],"DDDo","dayOfYear"),W("dayOfYear","DDD"),V("dayOfYear",4),pt("DDD",ot),pt("DDDD",tt),_t(["DDD","DDDD"],(function(t,e,r){r._dayOfYear=Z(t)})),C("m",["mm",2],0,"minute"),W("minute","m"),V("minute",14),pt("m",nt),pt("mm",nt,X),_t(["m","mm"],4);var fr=$("Minutes",!1);C("s",["ss",2],0,"second"),W("second","s"),V("second",15),pt("s",nt),pt("ss",nt,X),_t(["s","ss"],5);var hr,dr,pr=$("Seconds",!1);for(C("S",0,0,(function(){return~~(this.millisecond()/100)})),C(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),C(0,["SSS",3],0,"millisecond"),C(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),C(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),C(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),C(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),C(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),C(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),W("millisecond","ms"),V("millisecond",16),pt("S",ot,K),pt("SS",ot,X),pt("SSS",ot,tt),hr="SSSS";hr.length<=9;hr+="S")pt(hr,ct);function yr(t,e){e[6]=Z(1e3*("0."+t))}for(hr="S";hr.length<=9;hr+="S")_t(hr,yr);dr=$("Milliseconds",!1),C("z",0,0,"zoneAbbr"),C("zz",0,0,"zoneName");var vr=b.prototype;function mr(t){return t}vr.add=Ze,vr.calendar=function(t,e){1===arguments.length&&(Je(arguments[0])?(t=arguments[0],e=void 0):Qe(arguments[0])&&(e=arguments[0],t=void 0));var r=t||xe(),i=Re(r,this).startOf("day"),a=n.calendarFormat(this,i)||"sameElse",o=e&&(Y(e[a])?e[a].call(this,r):e[a]);return this.format(o||this.localeData().calendar(a,this,xe(r)))},vr.clone=function(){return new b(this)},vr.diff=function(t,e,r){var n,i,a;if(!this.isValid())return NaN;if(!(n=Re(t,this)).isValid())return NaN;switch(i=6e4*(n.utcOffset()-this.utcOffset()),e=U(e)){case"year":a=Ke(this,n)/12;break;case"month":a=Ke(this,n);break;case"quarter":a=Ke(this,n)/3;break;case"second":a=(this-n)/1e3;break;case"minute":a=(this-n)/6e4;break;case"hour":a=(this-n)/36e5;break;case"day":a=(this-n-i)/864e5;break;case"week":a=(this-n-i)/6048e5;break;default:a=this-n}return r?a:q(a)},vr.endOf=function(t){var e,r;if(void 0===(t=U(t))||"millisecond"===t||!this.isValid())return this;switch(r=this._isUTC?ir:nr,t){case"year":e=r(this.year()+1,0,1)-1;break;case"quarter":e=r(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=r(this.year(),this.month()+1,1)-1;break;case"week":e=r(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=r(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=r(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=36e5-rr(e+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":e=this._d.valueOf(),e+=6e4-rr(e,6e4)-1;break;case"second":e=this._d.valueOf(),e+=1e3-rr(e,1e3)-1}return this._d.setTime(e),n.updateOffset(this,!0),this},vr.format=function(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=R(this,t);return this.localeData().postformat(e)},vr.from=function(t,e){return this.isValid()&&(S(t)&&t.isValid()||xe(t).isValid())?He({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},vr.fromNow=function(t){return this.from(xe(),t)},vr.to=function(t,e){return this.isValid()&&(S(t)&&t.isValid()||xe(t).isValid())?He({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},vr.toNow=function(t){return this.to(xe(),t)},vr.get=function(t){return Y(this[t=U(t)])?this[t]():this},vr.invalidAt=function(){return y(this).overflow},vr.isAfter=function(t,e){var r=S(t)?t:xe(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=U(e)||"millisecond")?this.valueOf()>r.valueOf():r.valueOf()<this.clone().startOf(e).valueOf())},vr.isBefore=function(t,e){var r=S(t)?t:xe(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=U(e)||"millisecond")?this.valueOf()<r.valueOf():this.clone().endOf(e).valueOf()<r.valueOf())},vr.isBetween=function(t,e,r,n){var i=S(t)?t:xe(t),a=S(e)?e:xe(e);return!!(this.isValid()&&i.isValid()&&a.isValid())&&(("("===(n=n||"()")[0]?this.isAfter(i,r):!this.isBefore(i,r))&&(")"===n[1]?this.isBefore(a,r):!this.isAfter(a,r)))},vr.isSame=function(t,e){var r,n=S(t)?t:xe(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=U(e)||"millisecond")?this.valueOf()===n.valueOf():(r=n.valueOf(),this.clone().startOf(e).valueOf()<=r&&r<=this.clone().endOf(e).valueOf()))},vr.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},vr.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},vr.isValid=function(){return v(this)},vr.lang=tr,vr.locale=Xe,vr.localeData=er,vr.max=Ye,vr.min=Me,vr.parsingFlags=function(){return d({},y(this))},vr.set=function(t,e){if("object"==typeof t){var r,n=function(t){var e,r=[];for(e in t)s(t,e)&&r.push({unit:e,priority:G[e]});return r.sort((function(t,e){return t.priority-e.priority})),r}(t=H(t));for(r=0;r<n.length;r++)this[n[r].unit](t[n[r].unit])}else if(Y(this[t=U(t)]))return this[t](e);return this},vr.startOf=function(t){var e,r;if(void 0===(t=U(t))||"millisecond"===t||!this.isValid())return this;switch(r=this._isUTC?ir:nr,t){case"year":e=r(this.year(),0,1);break;case"quarter":e=r(this.year(),this.month()-this.month()%3,1);break;case"month":e=r(this.year(),this.month(),1);break;case"week":e=r(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=r(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=r(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=rr(e+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":e=this._d.valueOf(),e-=rr(e,6e4);break;case"second":e=this._d.valueOf(),e-=rr(e,1e3)}return this._d.setTime(e),n.updateOffset(this,!0),this},vr.subtract=$e,vr.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},vr.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},vr.toDate=function(){return new Date(this.valueOf())},vr.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,r=e?this.clone().utc():this;return r.year()<0||r.year()>9999?R(r,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):Y(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",R(r,"Z")):R(r,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},vr.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,r,n="moment",i="";return this.isLocal()||(n=0===this.utcOffset()?"moment.utc":"moment.parseZone",i="Z"),t="["+n+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r=i+'[")]',this.format(t+e+"-MM-DD[T]HH:mm:ss.SSS"+r)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(vr[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),vr.toJSON=function(){return this.isValid()?this.toISOString():null},vr.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},vr.unix=function(){return Math.floor(this.valueOf()/1e3)},vr.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},vr.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},vr.eraName=function(){var t,e,r,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(r=this.startOf("day").valueOf(),n[t].since<=r&&r<=n[t].until)return n[t].name;if(n[t].until<=r&&r<=n[t].since)return n[t].name}return""},vr.eraNarrow=function(){var t,e,r,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(r=this.startOf("day").valueOf(),n[t].since<=r&&r<=n[t].until)return n[t].narrow;if(n[t].until<=r&&r<=n[t].since)return n[t].narrow}return""},vr.eraAbbr=function(){var t,e,r,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(r=this.startOf("day").valueOf(),n[t].since<=r&&r<=n[t].until)return n[t].abbr;if(n[t].until<=r&&r<=n[t].since)return n[t].abbr}return""},vr.eraYear=function(){var t,e,r,i,a=this.localeData().eras();for(t=0,e=a.length;t<e;++t)if(r=a[t].since<=a[t].until?1:-1,i=this.startOf("day").valueOf(),a[t].since<=i&&i<=a[t].until||a[t].until<=i&&i<=a[t].since)return(this.year()-n(a[t].since).year())*r+a[t].offset;return this.year()},vr.year=Nt,vr.isLeapYear=function(){return z(this.year())},vr.weekYear=function(t){return ur.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},vr.isoWeekYear=function(t){return ur.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},vr.quarter=vr.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},vr.month=Pt,vr.daysInMonth=function(){return St(this.year(),this.month())},vr.week=vr.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},vr.isoWeek=vr.isoWeeks=function(t){var e=Lt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},vr.weeksInYear=function(){var t=this.localeData()._week;return Ft(this.year(),t.dow,t.doy)},vr.weeksInWeekYear=function(){var t=this.localeData()._week;return Ft(this.weekYear(),t.dow,t.doy)},vr.isoWeeksInYear=function(){return Ft(this.year(),1,4)},vr.isoWeeksInISOWeekYear=function(){return Ft(this.isoWeekYear(),1,4)},vr.date=lr,vr.day=vr.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},vr.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},vr.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},vr.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},vr.hour=vr.hours=Xt,vr.minute=vr.minutes=fr,vr.second=vr.seconds=pr,vr.millisecond=vr.milliseconds=dr,vr.utcOffset=function(t,e,r){var i,a=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ce(ht,t)))return this}else Math.abs(t)<16&&!r&&(t*=60);return!this._isUTC&&e&&(i=Le(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),a!==t&&(!e||this._changeInProgress?qe(this,He(t-a,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?a:Le(this)},vr.utc=function(t){return this.utcOffset(0,t)},vr.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Le(this),"m")),this},vr.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ce(ft,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},vr.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?xe(t).utcOffset():0,(this.utcOffset()-t)%60==0)},vr.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},vr.isLocal=function(){return!!this.isValid()&&!this._isUTC},vr.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},vr.isUtc=Fe,vr.isUTC=Fe,vr.zoneAbbr=function(){return this._isUTC?"UTC":""},vr.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},vr.dates=O("dates accessor is deprecated. Use date instead.",lr),vr.months=O("months accessor is deprecated. Use month instead",Pt),vr.years=O("years accessor is deprecated. Use year instead",Nt),vr.zone=O("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),vr.isDSTShifted=O("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!c(this._isDSTShifted))return this._isDSTShifted;var t,e={};return w(e,this),(e=Oe(e))._a?(t=e._isUTC?p(e._a):xe(e._a),this._isDSTShifted=this.isValid()&&function(t,e,r){var n,i=Math.min(t.length,e.length),a=Math.abs(t.length-e.length),o=0;for(n=0;n<i;n++)(r&&t[n]!==e[n]||!r&&Z(t[n])!==Z(e[n]))&&o++;return o+a}(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var gr=P.prototype;function _r(t,e,r,n){var i=ue(),a=p().set(n,e);return i[r](a,t)}function wr(t,e,r){if(l(t)&&(e=t,t=void 0),t=t||"",null!=e)return _r(t,e,r,"month");var n,i=[];for(n=0;n<12;n++)i[n]=_r(t,n,r,"month");return i}function br(t,e,r,n){"boolean"==typeof t?(l(e)&&(r=e,e=void 0),e=e||""):(r=e=t,t=!1,l(e)&&(r=e,e=void 0),e=e||"");var i,a=ue(),o=t?a._week.dow:0,s=[];if(null!=r)return _r(e,(r+o)%7,n,"day");for(i=0;i<7;i++)s[i]=_r(e,(i+o)%7,n,"day");return s}gr.calendar=function(t,e,r){var n=this._calendar[t]||this._calendar.sameElse;return Y(n)?n.call(e,r):n},gr.longDateFormat=function(t){var e=this._longDateFormat[t],r=this._longDateFormat[t.toUpperCase()];return e||!r?e:(this._longDateFormat[t]=r.match(A).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])},gr.invalidDate=function(){return this._invalidDate},gr.ordinal=function(t){return this._ordinal.replace("%d",t)},gr.preparse=mr,gr.postformat=mr,gr.relativeTime=function(t,e,r,n){var i=this._relativeTime[r];return Y(i)?i(t,e,r,n):i.replace(/%d/i,t)},gr.pastFuture=function(t,e){var r=this._relativeTime[t>0?"future":"past"];return Y(r)?r(e):r.replace(/%s/i,e)},gr.set=function(t){var e,r;for(r in t)s(t,r)&&(Y(e=t[r])?this[r]=e:this["_"+r]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},gr.eras=function(t,e){var r,i,a,o=this._eras||ue("en")._eras;for(r=0,i=o.length;r<i;++r){switch(typeof o[r].since){case"string":a=n(o[r].since).startOf("day"),o[r].since=a.valueOf()}switch(typeof o[r].until){case"undefined":o[r].until=1/0;break;case"string":a=n(o[r].until).startOf("day").valueOf(),o[r].until=a.valueOf()}}return o},gr.erasParse=function(t,e,r){var n,i,a,o,s,u=this.eras();for(t=t.toUpperCase(),n=0,i=u.length;n<i;++n)if(a=u[n].name.toUpperCase(),o=u[n].abbr.toUpperCase(),s=u[n].narrow.toUpperCase(),r)switch(e){case"N":case"NN":case"NNN":if(o===t)return u[n];break;case"NNNN":if(a===t)return u[n];break;case"NNNNN":if(s===t)return u[n]}else if([a,o,s].indexOf(t)>=0)return u[n]},gr.erasConvertYear=function(t,e){var r=t.since<=t.until?1:-1;return void 0===e?n(t.since).year():n(t.since).year()+(e-t.offset)*r},gr.erasAbbrRegex=function(t){return s(this,"_erasAbbrRegex")||or.call(this),t?this._erasAbbrRegex:this._erasRegex},gr.erasNameRegex=function(t){return s(this,"_erasNameRegex")||or.call(this),t?this._erasNameRegex:this._erasRegex},gr.erasNarrowRegex=function(t){return s(this,"_erasNarrowRegex")||or.call(this),t?this._erasNarrowRegex:this._erasRegex},gr.months=function(t,e){return t?a(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||Dt).test(e)?"format":"standalone"][t.month()]:a(this._months)?this._months:this._months.standalone},gr.monthsShort=function(t,e){return t?a(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[Dt.test(e)?"format":"standalone"][t.month()]:a(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},gr.monthsParse=function(t,e,r){var n,i,a;if(this._monthsParseExact)return Yt.call(this,t,e,r);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(i=p([2e3,n]),r&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),r||this._monthsParse[n]||(a="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[n]=new RegExp(a.replace(".",""),"i")),r&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(r&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!r&&this._monthsParse[n].test(t))return n}},gr.monthsRegex=function(t){return this._monthsParseExact?(s(this,"_monthsRegex")||jt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(s(this,"_monthsRegex")||(this._monthsRegex=Mt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},gr.monthsShortRegex=function(t){return this._monthsParseExact?(s(this,"_monthsRegex")||jt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(s(this,"_monthsShortRegex")||(this._monthsShortRegex=xt),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},gr.week=function(t){return Lt(t,this._week.dow,this._week.doy).week},gr.firstDayOfYear=function(){return this._week.doy},gr.firstDayOfWeek=function(){return this._week.dow},gr.weekdays=function(t,e){var r=a(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Wt(r,this._week.dow):t?r[t.day()]:r},gr.weekdaysMin=function(t){return!0===t?Wt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},gr.weekdaysShort=function(t){return!0===t?Wt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},gr.weekdaysParse=function(t,e,r){var n,i,a;if(this._weekdaysParseExact)return Zt.call(this,t,e,r);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(i=p([2e3,1]).day(n),r&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(a="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[n]=new RegExp(a.replace(".",""),"i")),r&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(r&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(r&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!r&&this._weekdaysParse[n].test(t))return n}},gr.weekdaysRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||$t.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(s(this,"_weekdaysRegex")||(this._weekdaysRegex=Vt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},gr.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||$t.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(s(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=zt),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},gr.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||$t.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(s(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=qt),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},gr.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},gr.meridiem=function(t,e,r){return t>11?r?"pm":"PM":r?"am":"AM"},oe("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===Z(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=O("moment.lang is deprecated. Use moment.locale instead.",oe),n.langData=O("moment.langData is deprecated. Use moment.localeData instead.",ue);var Sr=Math.abs;function kr(t,e,r,n){var i=He(e,r);return t._milliseconds+=n*i._milliseconds,t._days+=n*i._days,t._months+=n*i._months,t._bubble()}function Or(t){return t<0?Math.floor(t):Math.ceil(t)}function Dr(t){return 4800*t/146097}function xr(t){return 146097*t/4800}function Mr(t){return function(){return this.as(t)}}var Yr=Mr("ms"),Tr=Mr("s"),Pr=Mr("m"),jr=Mr("h"),Ar=Mr("d"),Nr=Mr("w"),Er=Mr("M"),Ir=Mr("Q"),Cr=Mr("y");function Rr(t){return function(){return this.isValid()?this._data[t]:NaN}}var Lr=Rr("milliseconds"),Fr=Rr("seconds"),Wr=Rr("minutes"),Ur=Rr("hours"),Hr=Rr("days"),Gr=Rr("months"),Vr=Rr("years"),zr=Math.round,qr={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function Zr(t,e,r,n,i){return i.relativeTime(e||1,!!r,t,n)}var $r=Math.abs;function Br(t){return(t>0)-(t<0)||+t}function Jr(){if(!this.isValid())return this.localeData().invalidDate();var t,e,r,n,i,a,o,s,u=$r(this._milliseconds)/1e3,c=$r(this._days),l=$r(this._months),f=this.asSeconds();return f?(t=q(u/60),e=q(t/60),u%=60,t%=60,r=q(l/12),l%=12,n=u?u.toFixed(3).replace(/\.?0+$/,""):"",i=f<0?"-":"",a=Br(this._months)!==Br(f)?"-":"",o=Br(this._days)!==Br(f)?"-":"",s=Br(this._milliseconds)!==Br(f)?"-":"",i+"P"+(r?a+r+"Y":"")+(l?a+l+"M":"")+(c?o+c+"D":"")+(e||t||u?"T":"")+(e?s+e+"H":"")+(t?s+t+"M":"")+(u?s+n+"S":"")):"P0D"}var Qr=je.prototype;return Qr.isValid=function(){return this._isValid},Qr.abs=function(){var t=this._data;return this._milliseconds=Sr(this._milliseconds),this._days=Sr(this._days),this._months=Sr(this._months),t.milliseconds=Sr(t.milliseconds),t.seconds=Sr(t.seconds),t.minutes=Sr(t.minutes),t.hours=Sr(t.hours),t.months=Sr(t.months),t.years=Sr(t.years),this},Qr.add=function(t,e){return kr(this,t,e,1)},Qr.subtract=function(t,e){return kr(this,t,e,-1)},Qr.as=function(t){if(!this.isValid())return NaN;var e,r,n=this._milliseconds;if("month"===(t=U(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,r=this._months+Dr(e),t){case"month":return r;case"quarter":return r/3;case"year":return r/12}else switch(e=this._days+Math.round(xr(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}},Qr.asMilliseconds=Yr,Qr.asSeconds=Tr,Qr.asMinutes=Pr,Qr.asHours=jr,Qr.asDays=Ar,Qr.asWeeks=Nr,Qr.asMonths=Er,Qr.asQuarters=Ir,Qr.asYears=Cr,Qr.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*Z(this._months/12):NaN},Qr._bubble=function(){var t,e,r,n,i,a=this._milliseconds,o=this._days,s=this._months,u=this._data;return a>=0&&o>=0&&s>=0||a<=0&&o<=0&&s<=0||(a+=864e5*Or(xr(s)+o),o=0,s=0),u.milliseconds=a%1e3,t=q(a/1e3),u.seconds=t%60,e=q(t/60),u.minutes=e%60,r=q(e/60),u.hours=r%24,o+=q(r/24),i=q(Dr(o)),s+=i,o-=Or(xr(i)),n=q(s/12),s%=12,u.days=o,u.months=s,u.years=n,this},Qr.clone=function(){return He(this)},Qr.get=function(t){return t=U(t),this.isValid()?this[t+"s"]():NaN},Qr.milliseconds=Lr,Qr.seconds=Fr,Qr.minutes=Wr,Qr.hours=Ur,Qr.days=Hr,Qr.weeks=function(){return q(this.days()/7)},Qr.months=Gr,Qr.years=Vr,Qr.humanize=function(t,e){if(!this.isValid())return this.localeData().invalidDate();var r,n,i=!1,a=qr;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(i=t),"object"==typeof e&&(a=Object.assign({},qr,e),null!=e.s&&null==e.ss&&(a.ss=e.s-1)),r=this.localeData(),n=function(t,e,r,n){var i=He(t).abs(),a=zr(i.as("s")),o=zr(i.as("m")),s=zr(i.as("h")),u=zr(i.as("d")),c=zr(i.as("M")),l=zr(i.as("w")),f=zr(i.as("y")),h=a<=r.ss&&["s",a]||a<r.s&&["ss",a]||o<=1&&["m"]||o<r.m&&["mm",o]||s<=1&&["h"]||s<r.h&&["hh",s]||u<=1&&["d"]||u<r.d&&["dd",u];return null!=r.w&&(h=h||l<=1&&["w"]||l<r.w&&["ww",l]),(h=h||c<=1&&["M"]||c<r.M&&["MM",c]||f<=1&&["y"]||["yy",f])[2]=e,h[3]=+t>0,h[4]=n,Zr.apply(null,h)}(this,!i,a,r),i&&(n=r.pastFuture(+this,n)),r.postformat(n)},Qr.toISOString=Jr,Qr.toString=Jr,Qr.toJSON=Jr,Qr.locale=Xe,Qr.localeData=er,Qr.toIsoString=O("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Jr),Qr.lang=tr,C("X",0,0,"unix"),C("x",0,0,"valueOf"),pt("x",lt),pt("X",/[+-]?\d+(\.\d{1,3})?/),_t("X",(function(t,e,r){r._d=new Date(1e3*parseFloat(t))})),_t("x",(function(t,e,r){r._d=new Date(Z(t))})),//! moment.js
n.version="2.26.0",e=xe,n.fn=vr,n.min=function(){var t=[].slice.call(arguments,0);return Te("isBefore",t)},n.max=function(){var t=[].slice.call(arguments,0);return Te("isAfter",t)},n.now=function(){return Date.now?Date.now():+new Date},n.utc=p,n.unix=function(t){return xe(1e3*t)},n.months=function(t,e){return wr(t,e,"months")},n.isDate=f,n.locale=oe,n.invalid=m,n.duration=He,n.isMoment=S,n.weekdays=function(t,e,r){return br(t,e,r,"weekdays")},n.parseZone=function(){return xe.apply(null,arguments).parseZone()},n.localeData=ue,n.isDuration=Ae,n.monthsShort=function(t,e){return wr(t,e,"monthsShort")},n.weekdaysMin=function(t,e,r){return br(t,e,r,"weekdaysMin")},n.defineLocale=se,n.updateLocale=function(t,e){if(null!=e){var r,n,i=te;null!=ee[t]&&null!=ee[t].parentLocale?ee[t].set(T(ee[t]._config,e)):(null!=(n=ae(t))&&(i=n._config),e=T(i,e),null==n&&(e.abbr=t),(r=new P(e)).parentLocale=ee[t],ee[t]=r),oe(t)}else null!=ee[t]&&(null!=ee[t].parentLocale?(ee[t]=ee[t].parentLocale,t===oe()&&oe(t)):null!=ee[t]&&delete ee[t]);return ee[t]},n.locales=function(){return D(ee)},n.weekdaysShort=function(t,e,r){return br(t,e,r,"weekdaysShort")},n.normalizeUnits=U,n.relativeTimeRounding=function(t){return void 0===t?zr:"function"==typeof t&&(zr=t,!0)},n.relativeTimeThreshold=function(t,e){return void 0!==qr[t]&&(void 0===e?qr[t]:(qr[t]=e,"s"===t&&(qr.ss=e-1),!0))},n.calendarFormat=function(t,e){var r=t.diff(e,"days",!0);return r<-6?"sameElse":r<-1?"lastWeek":r<0?"lastDay":r<1?"sameDay":r<2?"nextDay":r<7?"nextWeek":"sameElse"},n.prototype=vr,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()})),qo=/^\/?Date\((-?\d+)/i;function Zo(t){return zo.isMoment(t)}function $o(t,e){var r;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Go(t)&&!isNaN(Date.parse(t))?zo(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(Ho(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(Zo(t))return new Date(t.valueOf());if(Go(t))return(r=qo.exec(t))?new Date(Number(r[1])):zo(new Date(t)).toDate();throw new Error("Cannot convert object of type "+Vo(t)+" to type Date");case"Moment":if(Ho(t))return zo(t);if(t instanceof Date)return zo(t.valueOf());if(Zo(t))return zo(t);if(Go(t))return r=qo.exec(t),zo(r?Number(r[1]):t);throw new Error("Cannot convert object of type "+Vo(t)+" to type Date");case"ISODate":if(Ho(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(Zo(t))return t.toDate().toISOString();if(Go(t))return(r=qo.exec(t))?new Date(Number(r[1])).toISOString():zo(t).format();throw new Error("Cannot convert object of type "+Vo(t)+" to type ISODate");case"ASPDate":if(Ho(t))return"/Date("+t+")/";if(t instanceof Date||Zo(t))return"/Date("+t.valueOf()+")/";if(Go(t))return"/Date("+((r=qo.exec(t))?new Date(Number(r[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+Vo(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function Bo(t){return"string"==typeof t||"number"==typeof t}var Jo=jt("splice"),Qo=It("splice",{ACCESSORS:!0,0:0,1:2}),Ko=Math.max,Xo=Math.min;z({target:"Array",proto:!0,forced:!Jo||!Qo},{splice:function(t,e){var r,n,i,a,o,s,u=tt(this),c=Q(u.length),l=_e(t,c),f=arguments.length;if(0===f?r=n=0:1===f?(r=0,n=c-l):(r=f-2,n=Xo(Ko(B(e),0),c-l)),c+r-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=dt(u,n),a=0;a<n;a++)(o=l+a)in u&&Ne(i,a,u[o]);if(i.length=n,r<n){for(a=l;a<c-n;a++)s=a+r,(o=a+n)in u?u[s]=u[o]:delete u[s];for(a=c;a>c-n+r;a--)delete u[a-1]}else if(r>n)for(a=c-n;a>l;a--)s=a+r-1,(o=a+n-1)in u?u[s]=u[o]:delete u[s];for(a=0;a<r;a++)u[a+l]=arguments[a+2];return u.length=c-n+r,i}});var ts=vt("Array").splice,es=Array.prototype,rs=function(t){var e=t.splice;return t===es||t instanceof Array&&e===es.splice?ts:e},ns=[].slice,is=/MSIE .\./.test(Dt),as=function(t){return function(e,r){var n=arguments.length>2,i=n?ns.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,r)}};z({global:!0,bind:!0,forced:is},{setTimeout:as(o.setTimeout),setInterval:as(o.setInterval)});var os=C.setTimeout,ss=function(){function t(e){ce(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return de(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,r=0;r<e.length;r++){var n=e[r];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var r=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];r.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=os((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;zr(t=rs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,r){var n=new t(r);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var i=[{name:"flush",original:void 0}];if(r&&r.replace)for(var a=0;a<r.replace.length;a++){var o=r.replace[a];i.push({name:o,original:e[o]}),n.replace(e,o)}return n._extended={object:e,methods:i},n}}]),t}(),us=function(){function t(){ce(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return de(t,[{key:"_trigger",value:function(t,e,r){var n,i;if("*"===t)throw new Error("Cannot trigger event *");zr(n=ha(i=[]).call(i,ca(this._subscribers[t]),ca(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=r?r:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var r;this._subscribers[t]=Zt(r=this._subscribers[t]).call(r,(function(t){return t!==e}))}}]),t}(),cs=(Ia("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ha),C.Set);function ls(t,e){var r;if(void 0===$n||null==Wn(t)){if(Va(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return fs(t,e);var n=pi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return ai(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return fs(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,o=!0,s=!1;return{s:function(){r=Fn(t)},n:function(){var t=r.next();return o=t.done,t},e:function(t){s=!0,a=t},f:function(){try{o||null==r.return||r.return()}finally{if(s)throw a}}}}function fs(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}var hs=function(){function t(e){ce(this,t),this._pairs=e}return de(t,[{key:xi,value:Oi.mark((function t(){var e,r,n,i,a;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ls(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=No(r.value,2),i=n[0],a=n[1],t.next=7,[i,a];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Oi.mark((function t(){var e,r,n,i,a;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ls(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=No(r.value,2),i=n[0],a=n[1],t.next=7,[i,a];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Oi.mark((function t(){var e,r,n,i;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ls(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=No(r.value,1),i=n[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Oi.mark((function t(){var e,r,n,i;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=ls(this._pairs),t.prev=1,e.s();case 3:if((r=e.n()).done){t.next=9;break}return n=No(r.value,2),i=n[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return Ut(t=ca(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return Ut(t=ca(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return ca(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=co(null),r=ls(this._pairs);try{for(r.s();!(t=r.n()).done;){var n=No(t.value,2),i=n[0],a=n[1];e[i]=a}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"toMap",value:function(){return new Ga(this._pairs)}},{key:"toIdSet",value:function(){return new cs(this.toIdArray())}},{key:"toItemSet",value:function(){return new cs(this.toItemArray())}},{key:"cache",value:function(){return new t(ca(this._pairs))}},{key:"distinct",value:function(t){var e,r=new cs,n=ls(this._pairs);try{for(n.s();!(e=n.n()).done;){var i=No(e.value,2),a=i[0],o=i[1];r.add(t(o,a))}}catch(t){n.e(t)}finally{n.f()}return r}},{key:"filter",value:function(e){var r=this._pairs;return new t(Ei({},xi,Oi.mark((function t(){var n,i,a,o,s;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=ls(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=10;break}if(a=No(i.value,2),o=a[0],s=a[1],!e(s,o)){t.next=8;break}return t.next=8,[o,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,r=ls(this._pairs);try{for(r.s();!(e=r.n()).done;){var n=No(e.value,2),i=n[0];t(n[1],i)}}catch(t){r.e(t)}finally{r.f()}}},{key:"map",value:function(e){var r=this._pairs;return new t(Ei({},xi,Oi.mark((function t(){var n,i,a,o,s;return Oi.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=ls(r),t.prev=1,n.s();case 3:if((i=n.n()).done){t.next=9;break}return a=No(i.value,2),o=a[0],s=a[1],t.next=7,[o,e(s,o)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Fn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var a=No(r.value,2),o=a[0],s=a[1],u=t(s,o);u>i&&(i=u,n=s)}return n}},{key:"min",value:function(t){var e=Fn(this._pairs),r=e.next();if(r.done)return null;for(var n=r.value[1],i=t(r.value[1],r.value[0]);!(r=e.next()).done;){var a=No(r.value,2),o=a[0],s=a[1],u=t(s,o);u<i&&(i=u,n=s)}return n}},{key:"reduce",value:function(t,e){var r,n=ls(this._pairs);try{for(n.s();!(r=n.n()).done;){var i=No(r.value,2),a=i[0];e=t(e,i[1],a)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var r=this;return new t(Ei({},xi,(function(){var t;return Fn(qi(t=ca(r._pairs)).call(t,(function(t,r){var n=No(t,2),i=n[0],a=n[1],o=No(r,2),s=o[0],u=o[1];return e(a,u,i,s)})))})))}}]),t}();function ds(t,e){var r=xa(t);if(An){var n=An(t);e&&(n=Zt(n).call(n,(function(e){return $r(t,e).enumerable}))),r.push.apply(r,n)}return r}function ps(t,e){var r;if(void 0===$n||null==Wn(t)){if(Va(t)||(r=function(t,e){var r;if(!t)return;if("string"==typeof t)return ys(t,e);var n=pi(r=Object.prototype.toString.call(t)).call(r,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return ai(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ys(t,e)}(t))||e&&t&&"number"==typeof t.length){r&&(t=r);var n=0,i=function(){};return{s:i,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var a,o=!0,s=!1;return{s:function(){r=Fn(t)},n:function(){var t=r.next();return o=t.done,t},e:function(t){s=!0,a=t},f:function(){try{o||null==r.return||r.return()}finally{if(s)throw a}}}}function ys(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=new Array(e);r<e;r++)n[r]=t[r];return n}function vs(t){var e=function(){if("undefined"==typeof Reflect||!_i)return!1;if(_i.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_i(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=eo(t);if(e){var i=eo(this).constructor;r=_i(n,arguments,i)}else r=n.apply(this,arguments);return Ka(this,r)}}var ms=function(){console.warn("Type coercion has been deprecated. Please, use data pipes instead. See https://visjs.github.io/vis-data/data/datapipe.html#TypeCoercion for more details with working migration example.")},gs=function(t){Ja(r,t);var e=vs(r);function r(t,n){var i;if(ce(this,r),i=e.call(this),t&&!Va(t)&&(n=t,t=[]),i._options=n||{},i._data=new Ga,i.length=0,i._idProp=i._options.fieldId||"id",i._type={},i._options.type){ms();for(var a=xa(i._options.type),o=0,s=a.length;o<s;o++){var u=a[o],c=i._options.type[u];i._type[u]="Date"==c||"ISODate"==c||"ASPDate"==c?"Date":c}}return t&&t.length&&i.add(t),i.setOptions(n),i}return de(r,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=ss.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Oa(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var r,n=this,i=[];if(Va(t)){var a=Ut(t).call(t,(function(t){return t[n._idProp]}));if(Sa(a).call(a,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var o=0,s=t.length;o<s;o++)r=this._addItem(t[o]),i.push(r)}else{if(!t||"object"!==Oa(t))throw new Error("Unknown dataType");r=this._addItem(t),i.push(r)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var r=this,n=[],i=[],a=[],o=[],s=this._idProp,u=function(t){var e=t[s];if(null!=e&&r._data.has(e)){var u=t,c=va({},r._data.get(e)),l=r._updateItem(u);i.push(l),o.push(u),a.push(c)}else{var f=r._addItem(t);n.push(f)}};if(Va(t))for(var c=0,l=t.length;c<l;c++)t[c]&&"object"===Oa(t[c])?u(t[c]):console.warn("Ignoring input item, which is not an object at index "+c);else{if(!t||"object"!==Oa(t))throw new Error("Unknown dataType");u(t)}if(n.length&&this._trigger("add",{items:n},e),i.length){var f={items:i,oldData:a,data:o};this._trigger("update",f,e)}return ha(n).call(n,i)}},{key:"updateOnly",value:function(t,e){var r,n=this;Va(t)||(t=[t]);var i=Ut(r=Ut(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(r,(function(t){var e=t.oldData,r=t.update,i=e[n._idProp],a=function(t){for(var e,r=arguments.length,n=new Array(r>1?r-1:0),i=1;i<r;i++)n[i-1]=arguments[i];return Lo.apply(void 0,ha(e=[{},t]).call(e,n))}(e,r);return n._data.set(i,a),{id:i,oldData:e,updatedData:a}}));if(i.length){var a={items:Ut(i).call(i,(function(t){return t.id})),oldData:Ut(i).call(i,(function(t){return t.oldData})),data:Ut(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",a,e),a.items}return[]}},{key:"get",value:function(t,e){var r=void 0,n=void 0,i=void 0;Bo(t)?(r=t,i=e):Va(t)?(n=t,i=e):i=t;var a=i&&"Object"===i.returnType?"Object":"Array",o=i&&i.type||this._options.type,s=i&&Zt(i),u=[],c=null,l=null,f=null;if(null!=r)(c=this._getItem(r,o))&&s&&!s(c)&&(c=null);else if(null!=n)for(var h=0,d=n.length;h<d;h++)null==(c=this._getItem(n[h],o))||s&&!s(c)||u.push(c);else for(var p,y=0,v=(l=ca(Ji(p=this._data).call(p))).length;y<v;y++)f=l[y],null==(c=this._getItem(f,o))||s&&!s(c)||u.push(c);if(i&&i.order&&null==r&&this._sort(u,i.order),i&&i.fields){var m=i.fields;if(null!=r&&null!=c)c=this._filterFields(c,m);else for(var g=0,_=u.length;g<_;g++)u[g]=this._filterFields(u[g],m)}if("Object"==a){for(var w={},b=0,S=u.length;b<S;b++){var k=u[b];w[k[this._idProp]]=k}return w}return null!=r?c:u}},{key:"getIds",value:function(t){var e,r,n=this._data,i=t&&Zt(t),a=t&&t.order,o=t&&t.type||this._options.type,s=ca(Ji(n).call(n)),u=[];if(i)if(a){r=[];for(var c=0,l=s.length;c<l;c++){var f=s[c];i(e=this._getItem(f,o))&&r.push(e)}this._sort(r,a);for(var h=0,d=r.length;h<d;h++)u.push(r[h][this._idProp])}else for(var p=0,y=s.length;p<y;p++){var v=s[p];i(e=this._getItem(v,o))&&u.push(e[this._idProp])}else if(a){r=[];for(var m=0,g=s.length;m<g;m++){var _=s[m];r.push(n.get(_))}this._sort(r,a);for(var w=0,b=r.length;w<b;w++)u.push(r[w][this._idProp])}else for(var S=0,k=s.length;S<k;S++){var O=s[S];e=n.get(O),u.push(e[this._idProp])}return u}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var r=e&&Zt(e),n=e&&e.type||this._options.type,i=this._data,a=ca(Ji(i).call(i));if(e&&e.order)for(var o=this.get(e),s=0,u=o.length;s<u;s++){var c=o[s];t(c,c[this._idProp])}else for(var l=0,f=a.length;l<f;l++){var h=a[l],d=this._getItem(h,n);r&&!r(d)||t(d,h)}}},{key:"map",value:function(t,e){for(var r=e&&Zt(e),n=e&&e.type||this._options.type,i=[],a=this._data,o=ca(Ji(a).call(a)),s=0,u=o.length;s<u;s++){var c=o[s],l=this._getItem(c,n);r&&!r(l)||i.push(t(l,c))}return e&&e.order&&this._sort(i,e.order),i}},{key:"_filterFields",value:function(t,e){var r;return t?ee(r=Va(e)?e:xa(e)).call(r,(function(e,r){return e[r]=t[r],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var r=e;qi(t).call(t,(function(t,e){var n=t[r],i=e[r];return n>i?1:n<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");qi(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var r=[],n=[],i=Va(t)?t:[t],a=0,o=i.length;a<o;a++){var s=this._remove(i[a]);if(s){var u=s[this._idProp];null!=u&&(r.push(u),n.push(s))}}return r.length&&this._trigger("remove",{items:r,oldData:n},e),r}},{key:"_remove",value:function(t){var e;if(Bo(t)?e=t:t&&"object"===Oa(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var r=this._data.get(e)||null;return this._data.delete(e),--this.length,r}return null}},{key:"clear",value:function(t){for(var e,r=ca(Ji(e=this._data).call(e)),n=[],i=0,a=r.length;i<a;i++)n.push(this._data.get(r[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:r,oldData:n},t),r}},{key:"max",value:function(t){var e,r,n=null,i=null,a=ps(Li(e=this._data).call(e));try{for(a.s();!(r=a.n()).done;){var o=r.value,s=o[t];"number"==typeof s&&(null==i||s>i)&&(n=o,i=s)}}catch(t){a.e(t)}finally{a.f()}return n||null}},{key:"min",value:function(t){var e,r,n=null,i=null,a=ps(Li(e=this._data).call(e));try{for(a.s();!(r=a.n()).done;){var o=r.value,s=o[t];"number"==typeof s&&(null==i||s<i)&&(n=o,i=s)}}catch(t){a.e(t)}finally{a.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,r=ca(Ji(e).call(e)),n=[],i=this._options.type&&this._options.type[t]||null,a=0,o=0,s=r.length;o<s;o++){for(var u=r[o],c=e.get(u)[t],l=!1,f=0;f<a;f++)if(n[f]==c){l=!0;break}l||void 0===c||(n[a]=c,a++)}if(i)for(var h=0,d=n.length;h<d;h++)n[h]=$o(n[h],i);return n}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data.has(e))throw new Error("Cannot add item: item with id "+e+" already exists")}else e=so(),t[this._idProp]=e;for(var r={},n=xa(t),i=0,a=n.length;i<a;i++){var o=n[i],s=this._type[o];r[o]=$o(t[o],s)}return this._data.set(e,r),++this.length,e}},{key:"_getItem",value:function(t,e){var r,n=this._data.get(t);if(!n)return null;var i=xa(n);if(e){ms(),r={};for(var a=0,o=i.length;a<o;a++){var s=i[a],u=n[s];r[s]=$o(u,e[s])}}else r=function(t){for(var e=1;e<arguments.length;e++){var r,n=null!=arguments[e]?arguments[e]:{};if(e%2)zr(r=ds(Object(n),!0)).call(r,(function(e){Ei(t,e,n[e])}));else if(Ee)Ye(t,Ee(n));else{var i;zr(i=ds(Object(n))).call(i,(function(e){ve(t,e,$r(n,e))}))}}return t}({},n);return null==r[this._idProp]&&(r[this._idProp]=n.id),r}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Ni(t)+")");var r=this._data.get(e);if(!r)throw new Error("Cannot update item: no item with id "+e+" found");for(var n=xa(t),i=0,a=n.length;i<a;i++){var o=n[i],s=this._type[o];r[o]=$o(t[o],s)}return e}},{key:"stream",value:function(t){if(t){var e=this._data;return new hs(Ei({},xi,Oi.mark((function r(){var n,i,a,o;return Oi.wrap((function(r){for(;;)switch(r.prev=r.next){case 0:n=ps(t),r.prev=1,n.s();case 3:if((i=n.n()).done){r.next=11;break}if(a=i.value,null==(o=e.get(a))){r.next=9;break}return r.next=9,[a,o];case 9:r.next=3;break;case 11:r.next=16;break;case 13:r.prev=13,r.t0=r.catch(1),n.e(r.t0);case 16:return r.prev=16,n.f(),r.finish(16);case 19:case"end":return r.stop()}}),r,null,[[1,13,16,19]])}))))}var r;return new hs(Ei({},xi,ue(r=ki(this._data)).call(r,this._data)))}}]),r}(us);function _s(t){var e=function(){if("undefined"==typeof Reflect||!_i)return!1;if(_i.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_i(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var r,n=eo(t);if(e){var i=eo(this).constructor;r=_i(n,arguments,i)}else r=n.apply(this,arguments);return Ka(this,r)}}var ws=function(t){Ja(r,t);var e=_s(r);function r(t,n){var i,a;return ce(this,r),(a=e.call(this)).length=0,a._ids=new cs,a._options=n||{},a._listener=ue(i=a._onEvent).call(i,Qa(a)),a.setData(t),a}return de(r,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:Zt(this._options)}),r=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:r})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:Zt(this._options)}),i=0,a=n.length;i<a;i++){var o=n[i];this._ids.add(o)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new gs;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:Zt(this._options)}),e=ca(this._ids),r={},n=[],i=[],a=[],o=0,s=t.length;o<s;o++){var u=t[o];r[u]=!0,this._ids.has(u)||(n.push(u),this._ids.add(u))}for(var c=0,l=e.length;c<l;c++){var f=e[c],h=this._data.get(f);null==h?console.error("If you see this, report it please."):r[f]||(i.push(f),a.push(h),this._ids.delete(f))}this.length+=n.length-i.length,n.length&&this._trigger("add",{items:n}),i.length&&this._trigger("remove",{items:i,oldData:a})}},{key:"get",value:function(t,e){if(null==this._data)return null;var r,n=null;Bo(t)||Va(t)?(n=t,r=e):r=t;var i=va({},this._options,r),a=Zt(this._options),o=r&&Zt(r);return a&&o&&(i.filter=function(t){return a(t)&&o(t)}),null==n?this._data.get(i):this._data.get(n,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,r=Zt(this._options),n=null!=t?Zt(t):null;return e=n?r?function(t){return r(t)&&n(t)}:n:r,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var r,n,i=Zt(this._options),a=e&&Zt(e);n=a?i?function(t){return i(t)&&a(t)}:a:i,zr(r=this._data).call(r,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var r,n,i=Zt(this._options),a=e&&Zt(e);return n=a?i?function(t){return i(t)&&a(t)}:a:i,Ut(r=this._data).call(r,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Ei({},xi,ue(e=Ji(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e="This data view has already been disposed of.";ve(this,"_data",{get:function(){throw new Error(e)},set:function(){throw new Error(e)},configurable:!1})}},{key:"_onEvent",value:function(t,e,r){if(e&&e.items&&this._data){var n=e.items,i=[],a=[],o=[],s=[],u=[],c=[];switch(t){case"add":for(var l=0,f=n.length;l<f;l++){var h=n[l];this.get(h)&&(this._ids.add(h),i.push(h))}break;case"update":for(var d=0,p=n.length;d<p;d++){var y=n[d];this.get(y)?this._ids.has(y)?(a.push(y),u.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(y),i.push(y)):this._ids.has(y)&&(this._ids.delete(y),o.push(y),c.push(e.oldData[d]))}break;case"remove":for(var v=0,m=n.length;v<m;v++){var g=n[v];this._ids.has(g)&&(this._ids.delete(g),o.push(g),c.push(e.oldData[v]))}}this.length+=i.length-o.length,i.length&&this._trigger("add",{items:i},r),a.length&&this._trigger("update",{items:a,oldData:s,data:u},r),o.length&&this._trigger("remove",{items:o,oldData:c},r)}}}]),r}(us);t.DELETE=Ro,t.DataSet=gs,t.DataStream=hs,t.DataView=ws,t.Queue=ss,t.createNewDataPipeFrom=function(t){return new ye(t)},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-data.min.js.map
